%define OBJDIR $RPM_BUILD_DIR/obj-binutils-%{_elinos_target_arch}

Name: elinos-binutils

Version: 2.11.2
Release: 1

Copyright: GPL
Source0: binutils-%{version}.tar.gz
Patch0: %{name}.patch
Buildroot: /var/tmp/%{name}-root
Buildarch: %{_elinos_host_arch}
Prefix: %{_elinos_install_prefix}
BuildRequires: elinos-rpmconfig

#
#  PACKAGE:  (default for SRPM)
#
Summary: A GNU collection of binary utilities for cross development.
Group: Development/Tools

%description
%{distribution}

This is the source RPM for the binutils binary packages in Hard Hat Linux.

#
# PACKAGE: (default for the RPM)
#

%package -n elinos-binutils-%{_elinos_rpmid}
Summary: A GNU collection of binary utilities for cross development.
Group: Development/Tools

%description -n elinos-binutils-%{_elinos_rpmid}
%{distribution}

Binutils is a collection of binary utilities, including ar (for creating,
modifying and extracting from archives), nm (for listing symbols from
object files), objcopy (for copying and translating object files),
objdump (for displaying information from object files), ranlib (for
generating an index for the contents of an archive), size (for listing
the section sizes of an object or archive file), strings (for listing
printable strings from files), strip (for discarding symbols), c++filt
(a filter for demangling encoded C++ symbols), addr2line (for converting
addresses to file and line), and nlmconv (for converting object code into
an NLM). 

Install binutils if you need to perform any of these types of actions on
binary files.  Most programmers will want to install binutils.



%prep
%setup -n binutils-%{version} -q
%patch0 -p1



%build

SRCDIR="$PWD"
rm -rf %{OBJDIR}
mkdir %{OBJDIR}
cd %{OBJDIR}

CC=gcc ${SRCDIR}/configure --prefix=%{_elinos_install_dir} \
	--target=%{_elinos_conftarget} \
	2>&1 | tee $SRCDIR/build.log

make 2>&1 | tee -a $SRCDIR/build.log



%install

SRCDIR="$PWD"
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/%{_elinos_conftarget}/bin
cd %{OBJDIR}

make \
	prefix=${RPM_BUILD_ROOT}/%{_elinos_install_dir} \
	install \
	2>&1 | tee -a $SRCDIR/build.log

cd ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/bin
for i in *
do
	mv $i "%{_elinos_tool_prefix}`echo $i | rev | awk -F- '{ print $1 }' | rev`"
done

cd ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/man/man1
for i in *
do
    mv $i "%{_elinos_tool_prefix}`echo $i | rev | awk -F- '{ print $1 }' | rev`"
done

cd ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/%{_elinos_conftarget}/bin
for i in nm strip ar ranlib as ld
do
	rm $i
	ln -s ../../bin/%{_elinos_tool_prefix}$i $i
done

rm -f ${RPM_BUILD_ROOT}%{_elinos_install_dir}/lib/libiberty.a
rm -f ${RPM_BUILD_ROOT}%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}c++filt
rm -f ${RPM_BUILD_ROOT}%{_elinos_install_dir}/man/man1/%{_elinos_tool_prefix}c++filt.1
rm -rf ${RPM_BUILD_ROOT}%{_elinos_install_dir}/share

%clean
rm -rf ${RPM_BUILD_ROOT}

%files -n elinos-binutils-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_install_prefix}/elinos

%changelog
* Tue Jun 13 2000 Mark Hatle <mhatle@mvista.com>
- Updated to a newer version fo binutils, and matched the build style of
  gcc and glibc

* Fri Mar 10 2000 Gilbert Coville <gilbert@mvista.com>
- Made more portable, added buildroot

* Fri Jan 21 2000 Gilbert Coville <gilbert@mvista.com>
- first cut at cross build environment in SPEC file
