Name: elinos-e2fsprogs
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 1.26
Release: 2

BuildArchitectures: noarch

Copyright: GPL
Source0: e2fsprogs-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (default for SRPM)
#
Summary: second extended file system management programs
Group: Development/System
AutoReqProv: no

%description
Tools to create and manipulate the second extended file system.

#
#  PACKAGE
#

%package -n elinos-e2fsprogs-%{_elinos_rpmid}
Summary: second extended file system management programs
Group: Development/System
AutoReqProv: no

%description -n elinos-e2fsprogs-%{_elinos_rpmid}
Tools to create and manipulate the second extended file system.

%files -n elinos-e2fsprogs-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n e2fsprogs-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

if [ "%{_elinos_cpu_endian}" = "little" ]; then
	bigendian=no
else
	bigendian=yes
fi
CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD=%{_elinos_tool_prefix}gcc \
NM=%{_elinos_tool_prefix}nm \
ac_cv_c_bigendian=$bigendian \
./configure --target=%{_elinos_conftarget} \
  --prefix=%{_elinos_target_dir}/%{_elinos_libc}/default

make \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

make \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default \
 root_prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default \
 install

%if "%{_elinos_libc}" == "%{_elinos_static_lib}"
make \
 CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}gcc -static" \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 clean all
make \
 CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}gcc -static" \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default \
 root_prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default \
 install
%endif

# provide tools also in host
%if "%{_elinos_target_arch}" == "x86_386"
%if "%{_elinos_libc}" == "libc6"
make distclean
./configure --prefix=%{_elinos_install_dir}
make \
 CC="gcc -static" \
 prefix=${RPM_BUILD_ROOT}%{_elinos_install_dir} \
 sbindir=${RPM_BUILD_ROOT}%{_elinos_install_dir}/bin \
 root_prefix=${RPM_BUILD_ROOT}%{_elinos_install_dir} \
 root_sbindir=${RPM_BUILD_ROOT}%{_elinos_install_dir}/bin \
 all install
%endif
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
