Name: elinos-fileutils
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 3.16
Release: 1

BuildArchitectures: noarch

Copyright: GPL
Source0: fileutils-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (SRPM)
#
Summary: File management utilities.
Group: Development/System
AutoReqProv: no

%description
%{distribution}

#
#  PACKAGE (RPM)
#

%package -n elinos-fileutils-%{_elinos_rpmid}
Summary: File management utilities.
Group: Development/System
AutoReqProv: no

%description -n elinos-fileutils-%{_elinos_rpmid}
These are the GNU file management utilities.  Most of these programs
have significant advantages over their Unix counterparts, such as
greater speed, additional options, and fewer arbitrary limits.
 
The programs that can be built with this package are: chgrp, chown,
chmod, cp, dd, df, du, install, ln, dir, vdir, ls, mkdir, mvdir, mkfifo,
mknod, mv, rm, rmdir, sync and touch.  But mvdir is built only on systems
that lack the rename system call.

%files -n elinos-fileutils-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n fileutils-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

if [ "%{_elinos_libc}" = "libc5" ]; then
        rx=--without-regex
else
        rx=""
fi                                                                              

export CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}"
export AR=%{_elinos_tool_prefix}ar
export RANLIB=%{_elinos_tool_prefix}ranlib
export LD=%{_elinos_tool_prefix}ld
export NM=%{_elinos_tool_prefix}nm
export HOST_CC=gcc

ac_cv_func_fnmatch_works=yes \
	./configure --host=%{_elinos_target_config} \
   	--build=%{_elinos_host_config} \
	--prefix=/ $rx
make all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

export CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}"
export AR=%{_elinos_tool_prefix}ar
export RANLIB=%{_elinos_tool_prefix}ranlib
export LD=%{_elinos_tool_prefix}ld
export NM=%{_elinos_tool_prefix}nm
export HOST_CC=gcc

make prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/extended/fileutils \
  install

%if "%{_elinos_libc}" == "%{_elinos_static_lib}"
make \
  CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
  prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/extended/fileutils \
  clean install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
