%define STDC_VERSION 2.10.0
%define GCC_VERSION 2.95.3
%define OBJDIR $RPM_BUILD_DIR/obj-gcc-%{_elinos_rpmid}

Summary: GNU Compiler Collection - Core package including C compiler
Name: elinos-gcc
Url: http://gcc.gnu.org/
Version: 2.95.3
Release: 1
Copyright: GPL
Group: Development/Languages

Source0: ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{GCC_VERSION}/gcc-%{GCC_VERSION}.tar.gz

Patch0: elinos-gcc.patch

Buildroot: /var/tmp/%{name}-%{GCC_VERSION}-root

Buildarch: %{_elinos_host_arch} noarch

Prefix: %{_elinos_install_prefix}

BuildRequires: elinos-rpmconfig elinos-linuxheaders-%{_elinos_rpmid}

#
#  PACKAGE:  DEFAULT (for the SRPM)   
#
Summary: GNU Compiler Collection - Core package including C and C++
Group: Development/Languages

%description
%{distribution}

This is the source RPM for the gcc binary packages in Hard Hat Linux.
 
#  
# PACKAGE: Default (for the RPM)
#

%ifnarch noarch
%package -n elinos-gcc-%{_elinos_rpmid}
Obsoletes: elinos-bootstrap-gcc-%{_elinos_rpmid}
Summary: GNU Compiler Collection - Core package including C compiler
Group: Development/Languages

%description -n elinos-gcc-%{_elinos_rpmid}
%{distribution}

GCC, the GNU Compiler Collection, is a free software project that intends to
further the development of GNU compilers using an open development
environment. The gcc package contains the GCC C compiler, a compiler aimed
at integrating all the optimizations and features necessary for a
high-performance and stable development environment.

Install gcc if you'd like to use the GNU Compiler Collection C compiler, you
will also need to install the cpp package.
%endif

%ifnarch noarch
%package -n elinos-c++-%{_elinos_rpmid}
Summary: C++ support for the GNU Compiler Collection.
Group: Development/Languages
Requires: elinos-gcc-%{_elinos_rpmid} = %{GCC_VERSION}-%{release}
Requires: elinos-libstdc++-%{_elinos_rpmid} = %{STDC_VERSION}-%{release}

%description -n elinos-c++-%{_elinos_rpmid}
This package adds C++ support to the GNU compiler collection. It includes
support for most of the current C++ specification, including templates and
exception handling. It does include the static standard C++ library and C++
header files; the library for dynamically linking programs is available
separately.

# The following are unsupported to they are if-ed out..
%if 0
%package -n elinos-%{_elinos_target_arch}-objc
Summary: Objective C support for the GNU Compiler Collection.
Group: Development/Languages
Requires: elinos-gcc-%{_elinos_rpmid} = %{GCC_VERSION}-%{release}
Requires: elinos-c++-%{_elinos_rpmid} = %{GCC_VERSION}-%{release}

%description -n elinos-%{_elinos_target_arch}-objc
Objective C is an object-oriented derivative of the C language, much like
C++ but with more dynamic capabilities than this. This package adds
Objective-C support to the GNU Compiler Collection. It includes the
Objective-C compiler and runtime that is needed for running Objective-C
programs.

Install gcc-objc if you are going to do Objective C development and you
would like to use the GNU Compiler Collection.  You will also need to
install the gcc package.

%package -n elinos-%{_elinos_target_arch}-g77
Summary: Fortran 77 support for the GNU Compiler Collection.
Group: Development/Languages
Requires: elinos-gcc-%{_elinos_rpmid} = %{GCC_VERSION}-%{release}

%description -n elinos-%{_elinos_target_arch}-g77
The gcc-g77 package provides support for compiling Fortran 77 programs with
the GNU Compiler Collection.

You should install gcc-g77 if you are going to do Fortran development and
you would like to use the GNU Compiler Collection.  You will also need to
install the gcc package.

%package -n elinos-%{_elinos_target_arch}-java
Summary: Java support for the GNU Compiler Collection.
Group: Development/Languages
Requires: elinos-gcc-%{_elinos_rpmid} = %{GCC_VERSION}-%{release}
Requires: libgcj

%description -n elinos-%{_elinos_target_arch}-java
The gcc-java package provides support for compiling Java programs
with the GNU Compiler Collection.

You should install gcc-java if you are going to do Java development and you
would like to use the GNU Compiler Collection.  You will also need to
install the gcc package and the libgcj package.

%package -n elinos-%{_elinos_target_arch}-chill
Summary: Chill support for the GNU Compiler Collection.
Group: Development/Languages
Requires: elinos-gcc-%{_elinos_rpmid} = %{GCC_VERSION}-%{release}

%description -n elinos-%{_elinos_target_arch}-chill
The gcc-chill package provides support for compiling Chill programs with the
GNU Compiler Collection. Chill is the "CCITT High-Level Language", where
CCITT is the old name for what is now ITU, the International
Telecommunications Union. It is is language in the Modula2 family, and
targets many of the same applications as Ada (especially large embedded
systems). Chill was never used much in the United States, but is still being
used in Europe, Brazil, Korea, and other places.

You will also need to install the gcc package.

#end of unsupported
%endif
#ifnarch noarch
%endif

%ifarch noarch
%package -n elinos-libstdc++-%{_elinos_rpmid}
Summary: c++ library for the GNU Compiler Collection.
Group: System Environment/Libraries
Version: %{STDC_VERSION}
buildarch: noarch
AutoReqProv: no

%description -n elinos-libstdc++-%{_elinos_rpmid}
GNU C++ runtime libraries
#ifarch noarch
%endif

%prep
%ifnarch noarch
%setup -n gcc-%{GCC_VERSION} -q
%patch0 -p1

# add support for dwarf2 debug on PPC
patch -p0 <RPMSOURCES/ppc-fsirl-updates.dpatch

# we don't need to build texinfo on a current Linux installation
rm -rf texinfo
%endif

%build

%ifnarch noarch

SRCDIR="$PWD"
rm -rf %{OBJDIR}
mkdir %{OBJDIR}
cd %{OBJDIR}

export PATH=$PATH:/sbin:/usr/sbin:%{_elinos_bin_dir}
export CONFIG_SHELL=%{_buildshell}

${SRCDIR}/configure \
	--prefix=%{_elinos_install_dir} \
	--host=%{_elinos_host_config} \
	--target=%{_elinos_conftarget} \
	--program-transform-name=s,^,%{_elinos_tool_prefix}, \
	--enable-shared \
	--enable-threads \
	--enable-languages=c,c++ \
	--with-headers=%{_elinos_include_dir} \
%if "%{_elinos_has_fpu}" == "no"
	--without-fp \
%endif
%if "%{_elinos_cpu_id}" != "%%%%{_elinos_cpu_id}"
	--with-cpu=%{_elinos_cpu_id} \
%endif
%if "%{_elinos_gcc_config}" != "%%%%{_elinos_gcc_config}"
	%{_elinos_gcc_config} \
%endif
	2>&1 | tee $SRCDIR/build.log
make LANGUAGES="c c++" 2>&1 | tee -a $SRCDIR/build.log
(cd gcc ; make elinos-relocation)

# workaround a bug in the handling of MAKEINFO in gcc-2.95
find -name "*.info"|xargs rm -f
find -name "*.info-[1-9]*"|xargs rm -f
make info MAKEINFO="makeinfo --no-split" | tee -a $SRCDIR/build.log

#if [ -x /usr/bin/runtest ]; then
#	make -k check 2>&1 | tee -a $SRCDIR/build.log
#else
#	echo "Dejagnu not installed, no selftests have been run." >$SRCDIR/build.log
#fi
#$SRCDIR/contrib/warn_summary <$SRCDIR/build.log >$SRCDIR/warn.summary
#$SRCDIR/contrib/test_summary -i $SRCDIR/warn.summary \
#	> $SRCDIR/check.summary

%endif

%install

%ifnarch noarch
SRCDIR="$PWD"
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/%{_elinos_conftarget}/bin
cd %{OBJDIR}

export PATH=$PATH:/sbin:/usr/sbin:%{_elinos_bin_dir}
export CONFIG_SHELL=%{_buildshell}

make install \
	prefix=$RPM_BUILD_ROOT/%{_elinos_install_dir} \
	MAKEINFO="makeinfo --no-split"
cp gcc/elinos-relocation $RPM_BUILD_ROOT/%{_elinos_install_dir}/bin

cp $SRCDIR/adjust-prefix $RPM_BUILD_ROOT/%{_elinos_install_dir}/bin
chmod +x $RPM_BUILD_ROOT/%{_elinos_install_dir}/bin/adjust-prefix

#ln -sf gcc $RPM_BUILD_ROOT/usr/bin/cc
#ln -sf gcc $RPM_BUILD_ROOT/usr/bin/egcs
#ln -sf g77 $RPM_BUILD_ROOT/usr/bin/f77
#
#ln -sf g77.1 $RPM_BUILD_ROOT/usr/man/man1/f77.1
#ln -sf cccp.1 $RPM_BUILD_ROOT/usr/man/man1/cpp.1

gzip -n -9f ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/info/*.info* 

(cd ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/%{_elinos_conftarget}/lib
%if "%{_elinos_cpu_type}" == "ppc" && "%{_elinos_has_fpu}" == "no"
cd nof
%endif
#--mkdir -p ${RPM_BUILD_ROOT}/%{_elinos_target_dir}/lib
#--STDCXX=libstdc++-libc6.1
#--STDCXX3=libstdc++-3-libc6.1
#--%if "%{_elinos_libc}" == "libc5"
#--STDCXX=libstdc++-libc5
#--STDCXX3=libstdc++-3-libc5
#--%endif
#--cp -fdp ${STDCXX}-2.so.3 ${RPM_BUILD_ROOT}/%{_elinos_target_dir}/lib
#--mv ${STDCXX3}-2-%{STDC_VERSION}.so ${RPM_BUILD_ROOT}/%{_elinos_target_dir}/lib
#--cp ${RPM_BUILD_ROOT}/%{_elinos_target_dir}/${STDCXX3}-2-%{STDC_VERSION}.so .
)

#endif noarch
%endif

%if "%{_elinos_libc}" == "libc5"
#libc5 brings this file too, so avoid collision
rm -f ${RPM_BUILD_ROOT}/%{_elinos_install_dir}/%{_elinos_conftarget}/include/_G_config.h
%endif

%clean
%ifarch noarch
rm -rf $RPM_BUILD_ROOT
%endif

%ifnarch noarch
%post -n elinos-gcc-%{_elinos_rpmid}
if [ ${RPM_INSTALL_PREFIX} != %{_elinos_install_prefix} ]; then
  RELOCATION=${RPM_INSTALL_PREFIX}`expr %{_elinos_install_dir} : "%{_elinos_install_prefix}\(.*\)"`
  cd $RELOCATION/bin
  FILES="%{_elinos_tool_prefix}gcc %{_elinos_tool_prefix}cpp %{_elinos_tool_prefix}gcov %{_elinos_tool_prefix}protoize %{_elinos_tool_prefix}unprotoize"
  for i in $FILES ; do
    (mv $i $i.real ; ln -s elinos-relocation $i)
  done
  ./adjust-prefix elinos-relocation ${RPM_INSTALL_PREFIX} &> /dev/null
fi
%endif

%ifnarch noarch
%post -n elinos-c++-%{_elinos_rpmid}
if [ ${RPM_INSTALL_PREFIX} != %{_elinos_install_prefix} ]; then
  RELOCATION=${RPM_INSTALL_PREFIX}`expr %{_elinos_install_dir} : "%{_elinos_install_prefix}\(.*\)"`
  cd $RELOCATION/bin
  FILES="%{_elinos_tool_prefix}g++ %{_elinos_tool_prefix}c++ %{_elinos_tool_prefix}c++filt"
  for i in $FILES ; do
    (mv $i $i.real ; ln -s elinos-relocation $i)
  done
  # the actual setup and naming of elinos-relocation is done by the gcc.rpm
fi
#endif noarch
%endif

%ifnarch noarch
%files -n elinos-gcc-%{_elinos_rpmid}
%defattr(-,root,root)
#%doc README* COPYING COPYING.LIB build.log
%dir %{_elinos_install_dir}/lib/gcc-lib
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/nof
%endif
%if "%{_elinos_cpu_type}" == "sparc64"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/32
%endif

%{_elinos_install_dir}/bin/elinos-relocation
%{_elinos_install_dir}/bin/adjust-prefix
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}gcc
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}cpp
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}gcov
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}protoize
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}unprotoize
%{_elinos_install_dir}/info/gcc*
%{_elinos_install_dir}/man/man1/%{_elinos_tool_prefix}gcc.1*

%{_elinos_install_dir}/%{_elinos_conftarget}/bin/gcc
%{_elinos_install_dir}/%{_elinos_conftarget}/include

%{_elinos_install_dir}/%{_elinos_conftarget}/lib/libiberty.a

%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/nof/libiberty.a
%endif
%if "%{_elinos_cpu_type}" == "sparc64"
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/32/libiberty.a
%endif

%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/SYSCALLS.c.X

%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/cpp0
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/specs
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/cc1
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/collect2
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/libgcc.a

%if "%{_elinos_cpu_type}" == "ppc" 
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/nof/libgcc.a
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/nof/*crt*.o
%endif

%if "%{_elinos_cpu_type}" == "sparc64"
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/32/libgcc.a
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/32/*crt*.o
%endif

#%ifnarch alpha
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/*crt*.o
#%endif
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/README
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/float.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/iso646.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/limits.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/proto.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/stdarg.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/stdbool.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/stddef.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/syslimits.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/va-*.h
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/varargs.h
%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/*-asm.h
%endif

%files -n elinos-c++-%{_elinos_rpmid}
%defattr(-,root,root)
%dir %{_elinos_install_dir}/lib/gcc-lib
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/nof
%endif

%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}g++
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}c++
%{_elinos_install_dir}/bin/%{_elinos_tool_prefix}c++filt
%{_elinos_install_dir}/man/man1/%{_elinos_tool_prefix}g++.1*
%{_elinos_install_dir}/info/cpp*
%{_elinos_install_dir}/include/g++*
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/libstdc++*.a
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/libstdc++*.a.*

%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/nof/libstdc++*.a
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/nof/libstdc++*.a.*
%endif

%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/cc1plus
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/libstdc*

%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/nof/libstdc*
%endif

%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/exception
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/new
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/typeinfo
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/include/new.h

#endif noarch
%endif

# Unsupported
%if 0
%files -n elinos-%{_elinos_target_arch}-objc
%defattr(-,root,root)
%dir %{_elinos_install_dir}/lib/gcc-lib
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/include
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/nof
%endif

%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/cc1obj
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/libobjc.a
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/include/objc


%files -n elinos-%{_elinos_target_arch}-g77
%defattr(-,root,root)
%dir %{_elinos_install_dir}/lib/gcc-lib
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/include
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/nof
%endif

%{_elinos_install_dir}/bin/g77
%{_elinos_install_dir}/bin/f77
%{_elinos_install_dir}/info/g77*
%{_elinos_install_dir}/man/man1/g77.1*
%{_elinos_install_dir}/man/man1/f77.1*
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/f771
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/libg2c.a
%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/*/libg2c.a
%endif
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/include/g2c.h


%files -n elinos-%{_elinos_target_arch}-chill
%defattr(-,root,root)
%dir %{_elinos_install_dir}/lib/gcc-lib
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/include
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/nof
%endif

%{_elinos_install_dir}/bin/chill
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/cc1chill
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/chillrt0.o
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/libchill.a
%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/*/chillrt0.o
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/*/libchill.a
%endif


%files -n elinos-%{_elinos_target_arch}-java
%defattr(-,root,root)
%dir %{_elinos_install_dir}/lib/gcc-lib
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/include
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/nof
%endif

%{_elinos_install_dir}/bin/gcj
%{_elinos_install_dir}/bin/gcjh
%{_elinos_install_dir}/bin/jcf-dump
%{_elinos_install_dir}/bin/jv-scan
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/jc1
%{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/*/jvgenmain

#end of unsupported
%endif

%ifarch noarch
%files -n elinos-libstdc++-%{_elinos_rpmid}
%defattr(-,root,root)
#%ifarch alpha
#%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/ieee
#%endif
%if "%{_elinos_cpu_type}" == "ppc"
%dir %{_elinos_install_dir}/lib/gcc-lib/%{_elinos_conftarget}/%{GCC_VERSION}/nof
%endif

#--%{_elinos_target_dir}/lib/libstdc++*.so
#--%{_elinos_target_dir}/lib/libstdc++*.so.*
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/libstdc++*.so
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/libstdc++*.so.*

%if "%{_elinos_cpu_type}" == "ppc"
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/nof/libstdc++*.so
%{_elinos_install_dir}/%{_elinos_conftarget}/lib/nof/libstdc++*.so.*
%endif

#endif noarch
%endif

%changelog
* Wed Oct 09 2001 Marius Grger <mag@sysgo.de>
- created
