%define OBJDIR $RPM_BUILD_DIR/obj-glibc-%{_elinos_target_arch}

Name: elinos-glibc

Version: 2.1.3
Release: 3

Copyright: LGPL
Source0: glibc-%{version}.tar.gz
Patch0: elinos-glibc.patch
Buildroot: /var/tmp/%{name}-root
Buildarch: noarch
Prefix: %{_elinos_install_prefix}
BuildRequires: elinos-rpmconfig

#
#  PACKAGE:  DEFAULT (for the SRPM)
#
Summary: The GNU C Run-Time Library
Group: System Environment/Libraries

%description
%{distribution}

#
# PACKAGE: Default (for the RPM)
# 

%package -n elinos-glibc-%{_elinos_target_arch}-%{_elinos_libc}
Summary: The GNU libc libraries.
Group: System Environment/Libraries
AutoReqProv: no

%description  -n elinos-glibc-%{_elinos_target_arch}-%{_elinos_libc}
%{distribution}

The glibc package contains standard libraries which are used by
multiple programs on the system. In order to save disk space and
memory, as well as to make upgrading easier, common system code is
kept in one place and shared between programs. This particular package
contains the most important sets of shared libraries: the standard C
library and the standard math library. Without these two libraries, a
Linux system will not function.  The glibc package also contains
national language (locale) support and timezone databases.

%prep

%setup -n glibc-%{version} -q
%patch0 -p1 -E

%if "%{_elinos_cpu_type}" == "ppc" && "%{_elinos_cache_size}" == "4"
cat glibc-2.1.3-860-cacheline.patch | patch -p1
%endif

%if "%{_elinos_target_arch}" == "ppc_4xx"
cat glibc-2.1.3-4xx-memset.patch | patch -p1
%endif

rm -rf %{OBJDIR}
mkdir %{OBJDIR}

%build

PATH=$PATH:%{_elinos_bin_dir}
SRCDIR="$PWD"
cd %{OBJDIR}

# No floating point of the following CPUs,
%if "%{_elinos_has_fpu}" == "no"
CC=%{_elinos_tool_prefix}gcc AS=%{_elinos_tool_prefix}as \
	LD=%{_elinos_tool_prefix}ld ${SRCDIR}/configure \
	--prefix=%{_elinos_install_dir}/%{_elinos_target_config} \
	--host=%{_elinos_target_config} \
	--enable-add-ons=crypt,linuxthreads \
	--with-headers=%{_elinos_include_dir} \
	--disable-profile \
	--without-cvs --without-fp 2>&1
%else
CC=%{_elinos_tool_prefix}gcc AS=%{_elinos_tool_prefix}as \
	LD=%{_elinos_tool_prefix}ld ${SRCDIR}/configure \
	--prefix=%{_elinos_install_dir}/%{_elinos_target_config} \
	--host=%{_elinos_target_config} \
	--enable-add-ons=crypt,linuxthreads \
	--with-headers=%{_elinos_include_dir} \
	--disable-profile \
	--sysconfdir=/etc \
	--without-cvs 2>&1
%endif

# preset default-rpath. Otherwise the dynamic linker defaults to
# searching /opt/elinos/cdk.... instead of just /lib
make sysconfdir="/etc" default-rpath="/usr/lib:/lib"

%install
SRCDIR="$PWD"
SRCDIR="$PWD"

PATH=$PATH:%{_elinos_bin_dir}

rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_elinos_install_dir}

cd %{OBJDIR}
make prefix=${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config} install 2>&1

# move target-runnable parts of lib over to target environment

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config}/lib

mkdir -p ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/lib

cp -p libc.so libc.so.old
sed -e "s=${RPM_BUILD_ROOT}/.*/lib/libc.so=libc.so=g" libc.so.old | sed -e "s=${RPM_BUILD_ROOT}/.*/lib/libc=libc=g" > libc.so
rm libc.so.old

#  Provide ld.so.1 for PPC systems.

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config}/lib

%if "%{_elinos_cpu_type}" == "ppc"
ln -sf ld-linux.so.2 ld.so.1 
%endif

# move bin and sbin stuff to bin in target environment

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config}

mkdir -p ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/bin
mv bin/* sbin/* ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/bin/

# fix up some binaries, they contain the configure prefix

cd ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/bin
for file in ldd tzselect ; do
  sed -e "s=%{_elinos_install_dir}/%{_elinos_conftarget}==g" $file >$file.sed
  mv $file.sed $file
done

# move share stuff to target environment

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config}

mkdir -p ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share
rm -rf ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share/i18n
mv share/i18n ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share/
rm -rf ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share/locale
mv share/locale ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share/
mkdir -p ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share/zoneinfo
cp -r share/zoneinfo/* ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/share/zoneinfo/.
rm -rf share/zoneinfo

# move libexec to target environment

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config}

mkdir -p ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/libexec
mv libexec/pt_chown ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/libexec/

# move etc stuff

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_target_config}
mkdir -p ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/etc
mv etc/rpc ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/etc/

# all done

%clean
rm -rf ${RPM_BUILD_ROOT}

%files -n elinos-glibc-%{_elinos_target_arch}-%{_elinos_libc}
%defattr(-,root,root)
%{_elinos_install_dir}
%if "%{_elinos_target_arch}" != "ppc_8xx"
%if "%{_elinos_target_arch}" != "ppc_4xx"
%{_elinos_target_dir}
%endif
%endif

%changelog
* Mon Mar 05 2001 Marius Groeger <mag@sysgo.de>
- don't create profiled version
- Initial Version
