Name: elinos-gzip
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 1.2.4
Release: 1

BuildArchitectures: noarch

Copyright: GPL
Source0: gzip-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (SRPM)
#
Summary: (de)compression of files
Group: Development/System
AutoReqProv: no

%description
%{distribution}

#
#  PACKAGE (RPM)
#

%package -n elinos-gzip-%{_elinos_rpmid}
Summary: (de)compression of files
Group: Development/System
AutoReqProv: no

%description -n elinos-gzip-%{_elinos_rpmid}
gzip (GNU zip) is a compression utility designed to be a replacement
for 'compress'. Its main advantages over compress are much better
compression and freedom from patented algorithms.  The GNU Project
uses it as the standard compression program for its system.

gunzip can currently decompress files created by gzip, compress or
pack. The detection of the input format is automatic.

%files -n elinos-gzip-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n gzip-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

export CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}"
export AR=%{_elinos_tool_prefix}ar
export RANLIB=%{_elinos_tool_prefix}ranlib
export LD=%{_elinos_tool_prefix}ld
export NM=%{_elinos_tool_prefix}nm
export HOST_CC=gcc

./configure --host=%{_elinos_target_config} \
   	--build=%{_elinos_host_config} \
	--prefix=/
make all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

export CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}"
export AR=%{_elinos_tool_prefix}ar
export RANLIB=%{_elinos_tool_prefix}ranlib
export LD=%{_elinos_tool_prefix}ld
export NM=%{_elinos_tool_prefix}nm
export HOST_CC=gcc

make prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/extended/gzip \
  install

%if "%{_elinos_libc}" == "%{_elinos_static_lib}"
make \
  CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
  prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/extended/gzip \
  clean install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
