Name: elinos-lilo
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 22.2
Release: 1

Copyright: GPL
Source0: lilo-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
BuildArchitectures: noarch
Prefix: %{_elinos_install_prefix}/elinos

#
#  PACKAGE:  DEFAULT (for the SRPM)
#
Summary: Generic Boot Loader for Linux
Group: Development/System
AutoReqProv: no

%description
%{distribution}

#
#  PACKAGE
#
%package -n elinos-lilo-%{_elinos_rpmid}
Summary: Generic Boot Loader for Linux
Group: Development/System
AutoReqProv: no

%description -n elinos-lilo-%{_elinos_rpmid}
LILO is a versatile boot loader for Linux. It does not depend on a specific
file system, can boot Linux kernel images from floppy disks and from hard
disks and can even act as a "boot manager" for other operating systems.
(such as PC/MS-DOS, DR DOS, OS/2, Windows 95, Windows NT, 386BSD, SCO UNIX,
Unixware)

%files -n elinos-lilo-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_install_prefix}/elinos

#
#  PREP
#
%prep
%setup -q -n lilo-%{version}
%patch0 -p1
chmod +x runlibc

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

make \
CC=%{_elinos_tool_prefix}gcc \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD=%{_elinos_tool_prefix}ld \
NM=%{_elinos_tool_prefix}nm \
AS86=%{_elinos_prefix}/cdk/x86/i8086/bin/as86 \
LD86=%{_elinos_prefix}/cdk/x86/i8086/bin/ld86 \
ROOT=%{_elinos_target_dir}/{_elinos_libc}/default \
ELINOS_LIBC=%{_elinos_libc} \
all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default
install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/usr
make \
CC=%{_elinos_tool_prefix}gcc \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD=%{_elinos_tool_prefix}ld \
NM=%{_elinos_tool_prefix}nm \
AS86=%{_elinos_prefix}/cdk/x86/i8086/bin/as86 \
LD86=%{_elinos_prefix}/cdk/x86/i8086/bin/ld86 \
ROOT=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default \
ELINOS_LIBC=%{_elinos_libc} \
install

# Build also static version. 
%if "%{_elinos_libc}" == "libc5"
install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default
install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/usr
make \
CC="%{_elinos_tool_prefix}gcc -static" \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD="%{_elinos_tool_prefix}ld -Bstatic" \
NM=%{_elinos_tool_prefix}nm \
AS86=%{_elinos_prefix}/cdk/x86/i8086/bin/as86 \
LD86=%{_elinos_prefix}/cdk/x86/i8086/bin/ld86 \
ROOT=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default \
ELINOS_LIBC=%{_elinos_libc} \
clean install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
