Name: elinos-ncurses
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 5.2
Release: 2

BuildArchitectures: noarch

Copyright: GPL
Source0: ncurses-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (default for SRPM)
#
Summary: A subroutine library for terminal-independent screen-painting
Group: Development/System
AutoReqProv: no

%description
%{distribution}

#
#  PACKAGE
#

%package -n elinos-ncurses-%{_elinos_rpmid}
Summary: A subroutine library for terminal-independent screen-painting
Group: Development/System
AutoReqProv: no

%description -n elinos-ncurses-%{_elinos_rpmid}
The curses package is a subroutine library for terminal-independent
screen-painting and input-event handling which presents a high level screen
model to the programmer, hiding differences between terminal types and doing
automatic optimization of output to change one screen full of text into
another. Curses uses terminfo, which is a database format that can describe
the capabilities of thousands of different terminals.

%files -n elinos-ncurses-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n ncurses-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

HOSTCC=gcc \
CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
CXX="%{_elinos_tool_prefix}g++ %{_elinos_cflags}" \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD=%{_elinos_tool_prefix}gcc \
NM=%{_elinos_tool_prefix}nm \
./configure \
 --host=%{_elinos_target_config} \
 --target=%{_elinos_conftarget} \
 --enable-termcap    \
 --with-fallbacks=xterm,linux,vt100 \
 --without-debug     \
 --without-profile   \
 --with-shared       \
 --with-normal       \
 --with-manpage-format=gzip \
 --with-manpage-renames=${PWD}/man/man_db.renames \
 --disable-overwrite \
 --disable-rpath     \
 --disable-leaks     \
 --enable-symlinks   \
 --enable-big-core   \
 --enable-const      \
 --enable-hashmap    \
 --enable-no-padding \
 --enable-symlinks   \
 --enable-sigwinch   \
 --prefix=%{_elinos_install_dir}/%{_elinos_conftarget}

make \
 HOSTCC=gcc \
 HOSTTIC=/usr/bin/tic \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 CXX="%{_elinos_tool_prefix}g++ %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

make \
 HOSTCC=gcc \
 HOSTTIC=/usr/bin/tic \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 CXX="%{_elinos_tool_prefix}g++ %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 prefix=${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_conftarget} \
 install

cd ${RPM_BUILD_ROOT}%{_elinos_install_dir}/%{_elinos_conftarget}/include
ln -s ncurses/ncurses.h ncurses.h
ln -s ncurses/ncurses.h curses.h
ln -s ncurses/term.h term.h

#
#  CLEAN
#
%clean

rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog

* Thu Mar 13 2001 Marius Grger <mgroeger@sysgo.de>
- First version
