Name: elinos-net-tools
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 1.54
Release: 2

BuildArchitectures: noarch

Copyright: GPL
Source0: net-tools-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos

#
#  PACKAGE (SRPM)
#
Summary: Elinos embedded filesystem packer
Group: Development/System
AutoReqProv: no
%description
%{distribution}

#
#  PACKAGE
#
%package -n elinos-net-tools-%{_elinos_rpmid}
Summary: Elinos embedded filesystem packer
Group: Development/System
AutoReqProv: no

%description -n elinos-net-tools-%{_elinos_rpmid}
This package includes the important tools for controlling the network
subsystem of the Linux kernel.  This includes arp, hostname, ifconfig,
netstat, rarp and route.  Additionally, this package contains
utilities relating to particular network hardware types (plipconfig,
slattach) and advanced aspects of IP configuration (iptunnel,
ipmaddr).

%files -n elinos-net-tools-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n net-tools-%{version}
%patch0 -p1


#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

rm -f config.cache

make \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}ld \
 NM=%{_elinos_tool_prefix}nm \
 BASEDIR=%{_elinos_target_dir}/%{_elinos_libc}/default \
 clean config all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

make \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}ld \
 NM=%{_elinos_tool_prefix}nm \
 STRIPTOOL=%{_elinos_tool_prefix}strip \
 BASEDIR=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default \
 install

%if "%{_elinos_libc}" == "%{_elinos_static_lib}"
make \
 CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}ld -Bstatic" \
 NM=%{_elinos_tool_prefix}nm \
 STRIPTOOL=%{_elinos_tool_prefix}strip \
 BASEDIR=%{_elinos_target_dir}/static/default \
 clean all
make \
 CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}ld -Bstatic" \
 NM=%{_elinos_tool_prefix}nm \
 STRIPTOOL=%{_elinos_tool_prefix}strip \
 BASEDIR=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default \
 install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
