Name: elinos-strace
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 4.3
Release: 1

BuildArchitectures: noarch

Copyright: Open Source
Source0: strace-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (default for SRPM)
#
Summary: System call tracer
Group: Development/System
AutoReqProv: no

%description
%{distribution}

#
#  PACKAGE
#

%package -n elinos-strace-%{_elinos_rpmid}
Summary: System call tracer
Group: Development/System
AutoReqProv: no

%description -n elinos-strace-%{_elinos_rpmid}
This is strace 4.0, a system call tracer for SunOS 4.x, Linux, System
V release 4, Solaris 2.x and Irix 5.x.  strace is released under a
Berkeley-style license at the request of Paul Kranenburg; see the file
COPYRIGHT for details.

%files -n elinos-strace-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n strace-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD=%{_elinos_tool_prefix}gcc \
NM=%{_elinos_tool_prefix}nm \
./configure --prefix=%{_elinos_target_dir}/%{_elinos_libc}/default \
 %{_elinos_conftarget}

make \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/bin
install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default/man/man1

make \
 CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default \
 install

%if "%{_elinos_libc}" == "%{_elinos_static_lib}"
make \
 CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}gcc -static" \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 prefix=%{_elinos_target_dir}/static/default \
 clean all
install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default/bin
install -d -m 755 ${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default/man/man1
make \
 CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}gcc -static" \
 NM=%{_elinos_tool_prefix}nm \
 STRIP=%{_elinos_tool_prefix}strip \
 prefix=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default \
 install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
