Name: elinos-tinylogin
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 0.80
Release: 1

BuildArchitectures: noarch

Copyright: Sysgo Real-Time Solutions GmbH
Source0: tinylogin-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (SRPM)
#
Summary: multi-call binary for user authentication
Group: Development/System
AutoReqProv: no

%description
%{distribution}

#
#  PACKAGE (RPM)
#

%package -n elinos-tinylogin-%{_elinos_rpmid}
Summary: multi-call binary for user authentication
Group: Development/System
AutoReqProv: no

%description -n elinos-tinylogin-%{_elinos_rpmid}
TinyLogin is a suite of tiny utilities in a multi-call binary, which
enables your system to handle user authentication, and setting of
passwords. It is a drop-in to works nicely with BusyBox (another
multi-call binary), and makes an excellent addition to any small or
embedded system.

%files -n elinos-tinylogin-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n tinylogin-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

CFLAGS="%{_elinos_cflags}"
LIBCRYPT=
%if "%{_elinos_libc}" == "libc5"
CFLAGS="%{_elinos_cflags} -DI_NEED_UPDWTMP"
LIBCRYPT="WITHOUT_LIBCRYPT=true"
%endif

make \
 CC="%{_elinos_tool_prefix}gcc $CFLAGS" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 CROSS=%{_elinos_tool_prefix} \
 $LIBCRYPT \
 PREFIX=%{_elinos_target_dir}/%{_elinos_libc}/tinylogin \
 all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

CFLAGS=
LIBCRYPT=
%if "%{_elinos_libc}" == "libc5"
CFLAGS=-DI_NEED_UPDWTMP
LIBCRYPT="WITHOUT_LIBCRYPT=true"
%endif

make \
 CC="%{_elinos_tool_prefix}gcc $CFLAGS" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD=%{_elinos_tool_prefix}gcc \
 NM=%{_elinos_tool_prefix}nm \
 CROSS=%{_elinos_tool_prefix} \
 $LIBCRYPT \
 PREFIX=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/tinylogin \
 install
 
%if "%{_elinos_libc}" == "%{_elinos_static_lib}"
make \
 CC="%{_elinos_tool_prefix}gcc -static $CFLAGS" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}gcc -static" \
 NM=%{_elinos_tool_prefix}nm \
 CROSS=%{_elinos_tool_prefix} \
 $LIBCRYPT \
 PREFIX=%{_elinos_target_dir}/static/tinylogin \
 clean all
make \
 CC="%{_elinos_tool_prefix}gcc -static $CFLAGS" \
 AR=%{_elinos_tool_prefix}ar \
 RANLIB=%{_elinos_tool_prefix}ranlib \
 LD="%{_elinos_tool_prefix}gcc -static" \
 NM=%{_elinos_tool_prefix}nm \
 CROSS=%{_elinos_tool_prefix} \
 $LIBCRYPT \
 PREFIX=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/tinylogin \
 install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
