Name: elinos-util-linux
Vendor: SYSGO Real-Time Solutions GmbH
Distribution: ELinOS
Packager: <support@elinos.com>
URL: http://www.elinos.com/

Version: 2.11a
Release: 1

BuildArchitectures: noarch

Copyright: GPL
Source0: util-linux-%{version}.tar.gz
Patch0: %{name}.patch
BuildRoot: /var/tmp/%{name}
Prefix: %{_elinos_install_prefix}/elinos


#
#  PACKAGE (default for SRPM)
#
Summary: A random collection of Linux utilities
Group: Development/System
AutoReqProv: no

%description
The stuff in the subdirectories mount, fdisk, disk-utils, text-utils,
misc-utils, sys-utils, getopt-* should be rather distribution-neutral, and
installing it does no harm.

#
#  PACKAGE
#

%package -n elinos-util-linux-%{_elinos_rpmid}
Summary: second extended file system management programs
Group: Development/System
AutoReqProv: no

%description -n elinos-util-linux-%{_elinos_rpmid}
The stuff in the subdirectories mount, fdisk, disk-utils, text-utils,
misc-utils, sys-utils, getopt-* should be rather distribution-neutral,
and installing it does no harm.

%files -n elinos-util-linux-%{_elinos_rpmid}
%defattr(-,root,root)
%{_elinos_prefix}

#
#  PREP
#
%prep
%setup -q -n util-linux-%{version}
%patch0 -p1

#
#  BUILD
#
%build

PATH=$PATH:%{_elinos_bin_dir}

CC="%{_elinos_tool_prefix}gcc %{_elinos_cflags}" \
AR=%{_elinos_tool_prefix}ar \
RANLIB=%{_elinos_tool_prefix}ranlib \
LD=%{_elinos_tool_prefix}gcc \
NM=%{_elinos_tool_prefix}nm \
./configure \
  --target=%{_elinos_conftarget} \
  --prefix=%{_elinos_target_dir}/%{_elinos_libc}/default

make CPU=%{_elinos_target_cpu} all

#
#  INSTALL
#
%install

PATH=$PATH:%{_elinos_bin_dir}

rm -rf $RPM_BUILD_ROOT

make CPU=%{_elinos_target_cpu} \
  DESTDIR=${RPM_BUILD_ROOT}%{_elinos_target_dir}/%{_elinos_libc}/default \
  USE_TTY_GROUP=no \
  INSTALLSUID='install -m 4755' \
  install

%if "%{_elinos_libc}" == "libc5"
make CPU=%{_elinos_target_cpu} \
  CC="%{_elinos_tool_prefix}gcc -static %{_elinos_cflags}" \
  DESTDIR=${RPM_BUILD_ROOT}%{_elinos_target_dir}/static/default \
  USE_TTY_GROUP=no \
  INSTALLSUID='install -m 4755' \
  clean all install
%endif

#
#  CLEAN
#
%clean
rm -rf $RPM_BUILD_ROOT


#
#  CHANGELOG
#
%changelog
