/*
 * arch/ppc/kernel/men824xali_wdog.c
 * 
 * MEN 824XALI early watchdog access
 *
 * Copyright 2001 MEN MIKRO ELEKTRONIK 
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#include <linux/time.h>
#include <linux/sched.h>
#include <linux/timer.h>
#include <asm/mpc10x.h>

int men824xwd_enable_ping_early = 0;

void men824xwd_ping_early(void)
{
  static unsigned long  *configAddr = (unsigned long  *)MPC10X_MAPB_CNFG_ADDR;
  static unsigned long  *configData = (unsigned long  *)MPC10X_MAPB_CNFG_DATA;
  unsigned long tmpValue;
  
  if (men824xwd_enable_ping_early) {
#if defined(CONFIG_MENB11) 
  *configAddr = 0x7ce00080;
  __asm__ volatile("eieio; sync");
  tmpValue = *configData;
  __asm__ volatile("eieio; sync");
  tmpValue = (tmpValue & 0xfffffbff) | ((tmpValue & 0x00000400) ^ 0x00000400);
  *configData = tmpValue;
  __asm__ volatile("eieio; sync");
#elif defined(CONFIG_MENA12)	
    *configAddr = 0xc0e00080;
    __asm__ volatile("eieio; sync");
    tmpValue = *configData;
    __asm__ volatile("eieio; sync");
    tmpValue = (tmpValue & 0xfffffffd) | ((tmpValue & 0x00000002) ^ 0x00000002);
    *configData = tmpValue;
    __asm__ volatile("eieio; sync");
#elif defined(CONFIG_MENF1N)
    /*
     * Not needed
     */
#else
# error No MEN board defined
#endif
  }
  return;
}
