/*
 * include/asm-ppc/men824xali_time.h
 * 
 * Definitions for the M48Txx and mc146818 series of Time of day/Real Time
 * Clock chips.
 *
 * Author: Mark A. Greer
 *         mgreer@mvista.com
 *
 * Copyright 2001 MontaVista Software Inc.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

/* Complete the todc.h for the men824xali board with RTC M41T56 */

#ifndef __PPC_KERNEL_MEN824XALI_TIME_H
#define __PPC_KERNEL_MEN824XALI_TIME_H

long		men824xali_time_init(void);
u_char		men824xali_rtc_read_val(int addr);
void 		men824xali_rtc_write_val(int addr, unsigned char val);
unsigned long	men824xali_get_rtc_time(void);
int		men824xali_set_rtc_time(unsigned long nowtime);
void		men824xali_calibrate_decr(void);

#endif /* __PPC_KERNEL_MEN824XALI_TIME_H */
