/*
 * arch/ppc/platforms/xlweb855t.c
 * 
 * Board routines for Honeywell XL-Web 855T
 *
 * Copyright 2002 SYSGO Realtime Solutions
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General  Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/errno.h>
#include <linux/types.h>
#include <linux/delay.h>

#include <asm/system.h>
#include <asm/io.h>
#include <asm/bootinfo.h>
#include <asm/mpc8xx.h>
#include <asm/machdep.h>
#include <asm/todc.h>

#include "xlweb855t.h"

void  cpm_spi_core_init(void);
extern int cpm_spi_core_read(uint, uint, ushort, char *, int);
extern int cpm_spi_core_write(uint, uint, ushort, char *, int);

static int spi_init_done = 1;

/*
 * set the boards RTC connected via SPI
 */
static int
xlweb855t_set_rtc_time(unsigned long time)
{
		if (!spi_init_done) {
/* 				cpm_spi_core_init(); */
				spi_init_done = 1;
		}

		return(0);
}

/*
 * get the boards RTC connected via SPI
 */
static unsigned long
xlweb855t_get_rtc_time(void)
{
		if (!spi_init_done) {
/* 				cpm_spi_core_init(); */
				spi_init_done = 1;
		}

		return(0);
}

/*
 * driver inits
 */
static int __init xlweb855t_init(void)
{
		printk(KERN_INFO "XL-Web855T init.\n");

		return(0);
}

__initcall(xlweb855t_init);

/*
 * some xlweb board specific init
 * (this is called from platform_init in
 * kernel/m8xx_setup.c)
 */
void __init
xlweb855t_board_init(void)
{
		ppc_md.set_rtc_time   = xlweb855t_set_rtc_time;
		ppc_md.get_rtc_time   = xlweb855t_get_rtc_time;
}

