/***************************************************************************
                                  strings.h
                             -------------------
    project:  USB device for Philips PDIUSBD12D

    begin                : Mon Dec 17 2001
    copyright            : (C) 2001 by HBM GmbH, Siegfried Wessler
    email                : siegfried.wessler@hbm.com

    latest official version:  Dec 12, 2002
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#define head(len) len,3
#define b(cha)    cha,0


#ifdef CP42
  char  USB_SerialNo_Str[] = {0,'P','4','2','p','0','0','0','0','0',0}; // Serial No has to be set externally
#endif
#ifdef CP22
  char  USB_SerialNo_Str[] = {0,'P','2','2','p','0','0','0','0','0',0}; // Serial No has to be set externally
#endif

char  String_un[] = {0,0};


UINT8 LAN_DATA[] = { head(4),
                        9,0 };         /*LANGID array (English) */

/*[1] MFG_STR --> "Hottinger Baldwin Messtechnik" -------------*/
UINT8 MFG_DATA[] = {
        head(30*2),
        b('H'),b('o'),b('t'),b('t'),b('i'),b('n'),b('g'),b('e'),b('r'),b(' '),
        b('B'),b('a'),b('l'),b('d'),b('w'),b('i'),b('n'),b(' '),
        b('M'),b('e'),b('s'),b('s'),b('t'),b('e'),b('c'),b('h'),b('n'),b('i'),b('k')
        };

/*[2] PID_STR --> "HBM CP22, Bulk" ------------------------*/
UINT8 PID_DATA[] = {
        head(15*2),
        b('H'),b('B'),b('M'),b(' '),
#ifdef CP42
        b('C'),b('P'),b('4'),b('2'),
#endif
#ifdef CP22
        b('C'),b('P'),b('2'),b('2'),
#endif
        b(','),b(' '),b('B'),b('u'),b('l'),b('k')
        };


/*[3] CFG_STR --> "Standard Configuration" -------------------------*/
UINT8 CFG_DATA[] = {
       46,3, 83,0,116,0, 97,0,110,0,100,0, 97,0,114,0,100,0, 32,0, 67,0
     ,111,0,110,0,102,0,105,0,103,0,117,0,114,0, 97,0,116,0,105,0,111,0
     ,110,0  };


/*[4] INT_STR --> "HBM Bulk Interface" -------------------------*/
UINT8 INT_DATA[] = {
        head(19*2),
        b('H'),b('B'),b('M'),b(' '),
        b('B'),b('u'),b('l'),b('k'),b(' '),
        b('I'),b('n'),b('t'),b('e'),b('r'),b('f'),b('a'),b('c'),b('e')
        };


UINT8 * STR_ind[] = {
        LAN_DATA,                            /*LANGID array (English) */
        MFG_DATA,                            /* */
        PID_DATA,                            /* */
        CFG_DATA,                            /* */
        INT_DATA                             /* */
};
#define MFG_STR_OFS   1      
#define PID_STR_OFS   2
#define CFG_STR_OFS   3
#define INT_STR_OFS   4
#define UNR_STR_OFS   5
#define SNR_STR_OFS   6     // Das steht im Descriptor
