/***************************************************************************
                          buffer.h  -  description
                             -------------------
    begin                : Mon Sep 15 2003
    copyright            : (C) 2003 by Arno Geissel
    email                : geissel@t-c-linux
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #ifndef __BUFFER_H__
 #define __BUFFER_H__

 #define OUTBUF_SIZE   32768
 #define INBUF_SIZE     4096

 typedef struct  _tFifoBuffer
 {
   unsigned char     *pwrite_outbuf;    // Pointer to outBuffer that write data from application into outBuffer.
   unsigned char     *psend_outbuf;     // Pointer to outBuffer that gets data out of outBuffer into TNT4882, running after pWriteAppl.
   unsigned char     *precv_inbuf;      // Pointer to inBuffer that writes data from TNT4882 into inBuffer.
   unsigned char     *pread_inbuf;      // Pointer to inBuffer that gets data out of inBuffer to application, running after pGetUSB.
   unsigned char     *old_recv_pointer; // old receive pointer before it is incremented when data is written in the inbuffer
   int               send_count;        // data in out buffer
   int               recv_count;        // data in in buffer
   wait_queue_head_t waitqueue;         // waitqueue for blocking user read call operation

   unsigned char     in_buffer[INBUF_SIZE];
   unsigned char     out_buffer[OUTBUF_SIZE];
 } tFifoBuffer;

 extern  tFifoBuffer main_buffer;

 int init_fifo_buffer(tFifoBuffer *buf);

 #endif
