/***************************************************************************
                          gpib.h  -  description
                             -------------------
    begin                : Wed Oct 15 2003
    copyright            : (C) 2003 by Arno Geissel
    email                : geissel@t-c-linux
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 #ifndef __GPIB_H__
 #define __GPIB_H__

  /*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-*/
  /*
   *   Ioctl function parameters.
   */
  #define X SIOCDEVPRIVATE          /* Offset of private ioctl functions      */

  #define GPIB_SET_PGPIB_ADDR    X+0x07  /* Write to address register         */
  #define GPIB_GET_PGPIB_ADDR    X+0x0D  /* Get our GPIB address from driver  */

  #define GPIB_GET_REGISTER      X+0x08  /* Read GPIB register                */
  #define GPIB_SET_REGISTER      X+0x09  /* write GPIB register               */

  #define GPIB_GET_EOIFLG        X+0x0A  /* get status of eoiflg              */
  #define GPIB_SET_EOIFLG        X+0x0B  /* set status of eoiflg              */

  #define CMD_NCMD                0
  #define CMD_QUIT                1
  #define CMD_HELP                2
  #define CMD_GADR                3
  #define CMD_SADR                4
  #define CMD_GREG                5
  #define CMD_SREG                6
  #define CMD_RDWR                7

  #define L_BUF              0x2000

 #endif
