/***************************************************************************
                          ga12.c  -  description
                             -------------------
    begin                : Fri Sep 14 2001
    copyright            : (C) 2001 by ag
    email                : arno.geissel@hbm.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <linux/version.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <asm/io.h>

#if CONFIG_MODVERSIONS==1
#define MODVERSIONS
#include <linux/modversions.h>
#endif

#include "cpxxnmi.h"
#include "nmi.h"
#include "../../cpxxapp/src/ga12.h"  // to share the GA12 ram structure
#include "../../cpxxapp/src/fifo.h"  // to share the GA12 ram structure

 S_GA12_RAM *ga12_ram;				        // virt. address of remapped GA12 data ram

 /***********************************************************************
 *  init_ga12: initialize ga12 device                                   *
 **--------------------------------------------------------------------**
 *  Eingabe :                                                           *
 *  Ausgabe : success:0; unsuccess:-1                                   *
 *  Globals : ga12_ram                                                  *
 ***********************************************************************/
 int set_nextpage(S_GA12_RAM *ram, int nextpage)
 {
   //long test;

   ram->STR1 &= ~STR1_NEXTPAGE_MASK;
   switch(nextpage)
   {
     case 0:
       ram->STR1 |= STR1_NEXTPAGE_0;
       break;
     case 1:
       ram->STR1 |= STR1_NEXTPAGE_1;
       break;
     case 2:
       ram->STR1 |= STR1_NEXTPAGE_2;
       break;
     case 3:
       ram->STR1 |= STR1_NEXTPAGE_3;
       break;
     default: return(-1);
   }
   //ram->STR2 |= STR2_PAGEINTSET;                                        // accept new setting
   //ram->STR2 &= ~STR2_PAGEINTSET;
   //test = ram->PIntRes;
   return(0);
 }


INT16 LinkTestNmi(void)
{
  INT16    cnt;
  UINT32   volatile *pvalue;
  UINT16   *pCnt;

  pvalue = &(ga12_ram->data_ram[LIN_DDP*SLOTS_PER_DDP + next_page]);      // use the linear page
  pCnt = &glbl_fifo->LinkTestCnt[0];

  for(cnt = 0; cnt < MAX_SUBADR; cnt++, pCnt++)
  {
    if(*pvalue++ & 0x0000000f)
    {
      *pCnt = *pCnt + 1;
    }
  }
  return(0);
}
