/***************************************************************************
                          nmi.c  -  description
                             -------------------
    begin                : Fri Sep 14 2001
    copyright            : (C) 2001 by ag
    email                : arno.geissel@hbm.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <asm/io.h>
#include <linux/nmi.h>    // needs to be modified from original file!

#include "cpxxnmi.h"
#include "nmi.h"
#include "target.h"//
#include "ga12.h"  // to share the GA12 ram structure
#include "fifo.h"  // to share the fifo structures
#include "link.h"  // to share some defines
#include "tom.h"   //
#include "ids.h"   //

#define WG_MARIN 1


//#define SHOWBIT_DEBUG

long            next_page = 0;
long            next_page_b = 0;
struct timeval  tv;
unsigned long   timetick1, timetick2;
unsigned long   usbtick;
INT16           rt_wakeup;

UINT32 bit_field[] = {
                       0x00000001, 0x00000002, 0x00000004, 0x00000008,
                       0x00000010, 0x00000020, 0x00000040, 0x00000080,
                       0x00000100, 0x00000200, 0x00000400, 0x00000800,
                       0x00001000, 0x00002000, 0x00004000, 0x00008000,
                       0x00010000, 0x00020000, 0x00040000, 0x00080000,
                       0x00100000, 0x00200000, 0x00400000, 0x00800000,
                       0x01000000, 0x02000000, 0x04000000, 0x08000000,
                       0x10000000, 0x20000000, 0x40000000, 0x80000000,
                     };

// poll GA12 status until DMA engine is ready
void wait_dma_ready(void)
{
  while(ga12_ram->STAT_0 & 0x0008000L)
  {
// #ifdef SHOWBIT_DEBUG
//     ga12_ram->OUTP |= 0x02;
//     ga12_ram->OUTP &= ~0x02;
// #endif
  };         // wait until last DMA is ready
}

// comparation of value and levels
INT32 compare_trigger(INT16 client, S_TRIGGER *event)
{
  INT32 value;
  INT16 gwpos = 1;

  switch(event->table)
  {
    case TRG_SRC_DR:  // source is data ram
      wait_dma_ready();
      value = ga12_ram->data_ram[LIN_DDP * SLOTS_PER_DDP + event->source + next_page];
      break;

    case TRG_SRC_TC:  // source is time channel
      value = tv.tv_sec;
      break;

    case TRG_SRC_DI:  // digital input
      value = ga12_ram->INP << 4;
      break;

    default:          // asynchronous channel
      switch(event->size)
      {
        case 2:
          value = (*((INT16*)fifo_ctrl[client][event->table].assblk + event->source)) << 16;
          break;

        case 4:
        default:
          value = fifo_ctrl[client][event->table].assblk[event->source];
          break;
      }
      break;
  }

  switch(event->mode)
  {
    case IDS_MV_LEV:
      switch(event->slope)
      {
        case IDS_pStatic:
          if((INT32)(value & 0xFFFFFF00L) >= event->level_1)
            return(TRIG);
          break;

        case IDS_nStatic:
          if((INT32)(value & 0xFFFFFF00L) <= event->level_1)
            return(TRIG);
          break;

        case IDS_pEdge:
          if((INT32)(value & 0xFFFFFF00L) >= event->level_1)
          {
            if(event->save == FALSE)
            {
              event->save = TRUE;
              return(TRIG);
            }
          }
          else
          {
            event->save = FALSE;
          }
          break;

        case IDS_nEdge:
          if((INT32)(value & 0xFFFFFF00L) <= event->level_1)
          {
            if(event->save == FALSE)
            {
              event->save = TRUE;
              return(TRIG);
            }
          }
          else
          {
            event->save = FALSE;
          }
          break;
      }
      return(NO_TRIG);

    case IDS_MV_WIN:
      switch(event->slope)
      {
        case IDS_pStatic:
          if((INT32)(value & 0xFFFFFF00L) >= event->level_1)
            if((INT32)(value & 0xFFFFFF00L) <= event->level_2)
              return(TRIG);
          break;

        case IDS_nStatic:
          if(((INT32)(value & 0xFFFFFF00L) <= event->level_1) ||
            ((INT32)(value & 0xFFFFFF00L) >= event->level_2))
              return(TRIG);
          break;

        case IDS_pEdge:
          if(((INT32)(value & 0xFFFFFF00L) >= event->level_1) &&
              ((INT32)(value & 0xFFFFFF00L) <= event->level_2))
          {
            if(event->save == FALSE)
            {
              event->save = TRUE;
              return(TRIG);
            }
          }
          else
          {
            event->save = FALSE;
          }
          break;

        case IDS_nEdge:
          if(((INT32)(value & 0xFFFFFF00L) <= event->level_1) ||
              ((INT32)(value & 0xFFFFFF00L) >= event->level_2))
          {
            if(event->save == FALSE)
            {
              event->save = TRUE;
              return(TRIG);
            }
          }
          else
          {
            event->save = FALSE;
          }
          break;
      }
      return(NO_TRIG);

    case IDS_ExtTr:
      gwpos <<= 1;
    case IDS_MV_GW4:
      gwpos <<= 1;
    case IDS_MV_GW3:
      gwpos <<= 1;
    case IDS_MV_GW2:
      gwpos <<= 1;
    case IDS_MV_GW1:
      switch(event->slope)
      {
        case IDS_pStatic:
          if(value & gwpos)
            return(TRIG);
          break;

        case IDS_nStatic:
          if(!(value & gwpos))
            return(TRIG);
          break;

        case IDS_pEdge:
          if(value & gwpos)
          {
            if(event->save == FALSE)
            {
              event->save = TRUE;
              return(TRIG);
            }
          }
          else
          {
            event->save = FALSE;
          }
          break;

        case IDS_nEdge:
          if(!(value & gwpos))
          {
            if(event->save == FALSE)
            {
              event->save = TRUE;
              return(TRIG);
            }
          }
          else
          {
            event->save = FALSE;
          }
          break;
      }
      return(NO_TRIG);

    case IDS_MV_TIME:          // NTP time trigger
      if((UINT32)value >= (UINT32)event->level_1)
        return(TRIG);
      return(NO_TRIG);
  }
  return(NO_TRIG);
}


// calculation of the individual trigger
INT32 calc_trigger(INT16 client, INT16 mode, INT16 init)
{
  INT16 event, flag;
  S_FIFOCLIENT *pclient = client_fifo + client;
  S_TRIGGER *trig_event = pclient->trg_event;

  switch(mode)
  {
    case TRG_START:
      if(pclient->starttrig & BF_TRIG_TRG)
      {
        pclient->starttrig &= ~BF_TRIG_TRG;
        return(TRIG);
      }

      switch(pclient->starttrig)
      {
        case IDS_AUS:
          return(NO_TRIG);

        case IDS_sofort:
          return(TRIG);

        case IDS_AND:
          flag = FALSE;
          for (event=FIRST_STARTEVENT; event<FIRST_STOPEVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              flag = TRUE;
              if(compare_trigger(client, &trig_event[event]) != TRIG)
                if(!init)
                  return(NO_TRIG);
            }
          }
          if(flag)
	  {
            return(TRIG);
	  }
          else
            return(NO_TRIG);

        case IDS_OR:
          for (event=FIRST_STARTEVENT; event<FIRST_STOPEVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              if(compare_trigger(client, &trig_event[event]) == TRIG)
	      {
                if(!init)
                {
                  return(TRIG);
                }
	      }
            }
          }
          return(NO_TRIG);
      }
      break;

    case TRG_STOP:
      if(pclient->stoptrig & BF_TRIG_TRG)
      {
        pclient->stoptrig &= ~BF_TRIG_TRG;
        return(TRIG);
      }

      switch(pclient->stoptrig)
      {
        case IDS_AUS:
          return(NO_TRIG);

        case IDS_sofort:
          return(TRIG);

        case IDS_AND:
          flag = FALSE;
          for (event=FIRST_STOPEVENT; event<FIRST_MRSTARTEVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              flag = TRUE;
              if(compare_trigger(client, &trig_event[event]) != TRIG)
                if(!init)
                  return(NO_TRIG);
            }
          }
          if(flag)
            return(TRIG);
          else
            return(NO_TRIG);

        case IDS_OR:
          for (event=FIRST_STOPEVENT; event<FIRST_MRSTARTEVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              if(compare_trigger(client, &trig_event[event]) == TRIG)
                if(!init)
                  return(TRIG);
            }
          }
          return(NO_TRIG);
       }
      break;

    case TRG_MRSTART:
      if(pclient->mrtrig & BF_TRIG_TRG)
      {
        pclient->mrtrig &= ~BF_TRIG_TRG;
        return(TRIG);
      }

      switch(pclient->mrtrig)
      {
        case IDS_AUS:
          return(NO_TRIG);

        case IDS_sofort:
          return(TRIG);

        case IDS_AND:
          flag = FALSE;
          for (event=FIRST_MRSTARTEVENT; event<FIRST_MRSTOPEVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              flag = TRUE;
              if(compare_trigger(client, &trig_event[event]) != TRIG)
                if(!init)
                  return(NO_TRIG);
            }
          }

          if(flag)
            return(TRIG);
          else
            return(NO_TRIG);

        case IDS_OR:
          for (event=FIRST_MRSTARTEVENT; event<FIRST_MRSTOPEVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              if(compare_trigger(client, &trig_event[event]) == TRIG)
                if(!init)
                  return(TRIG);
            }
          }
          return(NO_TRIG);
      }
      break;

    case TRG_MRSTOP:
      if(pclient->mrtrig & BF_TRIG_TRG)
      {
        pclient->mrtrig &= ~BF_TRIG_TRG;
        return(TRIG);
      }

      switch(pclient->mrtrig)
      {
        case IDS_AUS:
          return(NO_TRIG);

        case IDS_sofort:
          return(TRIG);

        case IDS_AND:
          flag = FALSE;
          for (event=FIRST_MRSTOPEVENT; event<LAST_MREVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              flag = TRUE;
              if(compare_trigger(client, &trig_event[event]) != TRIG)
                if(!init)
                  return(NO_TRIG);
            }
          }
          if(flag)
            return(TRIG);
          else
            return(NO_TRIG);

        case IDS_OR:
          for (event=FIRST_MRSTOPEVENT; event<LAST_MREVENT; event++)
          {
            if(trig_event[event].mode != IDS_AUS)
            {
              if(compare_trigger(client, &trig_event[event]) == TRIG)
                if(!init)
                  return(TRIG);
            }
          }
          return(NO_TRIG);
      }
      break;
  }
  return(NO_TRIG);
}


// set the ready bit on this client
void set_ready(S_FIFOCLIENT *pclient, INT32 value)
{
  if(value == TRUE)
  {
    glbl_fifo->ready_mask &= ~bit_field[pclient->trg_slot];
    //printk("setready %ld\n", pclient->trg_slot);
  }
  else
  {
    glbl_fifo->ready_mask |= bit_field[pclient->trg_slot];
    //printk("notready %ld\n", pclient->trg_slot);
  }
}


// set the start bit on this client
void set_start(S_FIFOCLIENT *pclient, INT32 value)
{
  if(pclient->trg_mode != TRG_SLAVE)
  {
    if(value == TRUE)
      glbl_fifo->start_mask |= bit_field[pclient->trg_slot];
    else
      glbl_fifo->start_mask &= ~bit_field[pclient->trg_slot];
  }
}


//get the ready bit on this client
INT32 get_ready(S_FIFOCLIENT *pclient)
{
  if ((glbl_fifo->ready_in & bit_field[pclient->trg_slot]) == 0)
    return TRUE;

  return FALSE;
}


// get the start bit on this client
INT32 get_start(S_FIFOCLIENT *pclient)
{
  if (glbl_fifo->start_in & bit_field[pclient->trg_slot])
    return TRUE;

  return FALSE;
}


// the general trigger routine
void trigger(INT16 client)
{
  S_FIFOCLIENT  *pclient = client_fifo + client;
  S_FIFO        *pfifo = fifo_ctrl[client];
  INT16         fifo;


  // calculate MR trigger
  if(pclient->mrtrig)
  {
    if(pfifo->rateact == pfifo->rate1)
    {
      if(glbl_fifo->start_in & bit_field[pclient->mrtrg_slot])
      {
        for(fifo=0; fifo<MAX_FIFO; fifo++, pfifo++)
          pfifo->rateact = pfifo->rate2;
        pclient->mrtrig &= ~BF_TRIG_ON;
        //printk("set to rate2\n");
      }
      else if(pclient->trg_mode != TRG_SLAVE)
      {
        if(calc_trigger(client, TRG_MRSTART, FALSE))
        {
          pclient->mrtrig_loop = pclient->mrtrig_cnt;

          glbl_fifo->start_mask |= bit_field[pclient->mrtrg_slot];
          //printk("starttrig\n");
        }
      }
    }
    else
    {
      if(!pclient->mrtrig_loop)
      {
        if(!(glbl_fifo->start_in & bit_field[pclient->mrtrg_slot]))
        {
          for(fifo=0; fifo<MAX_FIFO; fifo++, pfifo++)
            pfifo->rateact = pfifo->rate1;
          pclient->mrtrig &= ~BF_TRIG_ON;
          //printk("set to rate1\n");
        }
        else if(pclient->trg_mode != TRG_SLAVE)
        {
          if(calc_trigger(client, TRG_MRSTOP, FALSE))
          {
            glbl_fifo->start_mask &= ~bit_field[pclient->mrtrg_slot];
            //printk("stoptrig\n");
          }
        }
      }
    }
  }

  // calculate start or stop trigger
  if(glbl_fifo->start_in & bit_field[pclient->trg_slot])
  {
    if(pclient->vlbready && pclient->cmd_trigfifo == CMDFIFO_FILLVLB)  // P4.24
    {
      if(pclient->slope)                                    // P4.24
      {
        pclient->slope = FALSE;                             // P4.24
        pclient->cmd_trigfifo = CMDFIFO_ENDVLB;             // starttrigger received
        pclient->nlbready = FALSE;

        if(pclient->trg_mode != TRG_SLAVE)                  // P4.36
          calc_trigger(client, TRG_STOP, TRUE);             // initialize stop trigger
        //printk("starttrigger received on client %d, start_in %lx\n", client, glbl_fifo->start_in);
      }
    }
    else
    {
      pclient->waittrig = FALSE;
      if(pclient->trg_mode == TRG_SLAVE)                  // CP32 compatibility
      {
        if(pclient->cmd_trigfifo == CMDFIFO_FILLNLB)
        {
          if(pclient->nlbready)
          {
            pclient->vlbready = FALSE;
            pclient->cmd_trigfifo = CMDFIFO_ENDNLB;             // stoptrigger received

            if(pclient->trg_mode != TRG_SLAVE)                  // P4.36
              calc_trigger(client, TRG_START, TRUE);            // initialize start trigger
            //printk("nlbready\n");
          }
        }
      }
      else
      {
        if(pclient->trg_mode != TRG_SLAVE)                      // P4.24
          if(calc_trigger(client, TRG_STOP, FALSE))
          {
            glbl_fifo->start_mask &= ~bit_field[pclient->trg_slot];
            //printk("stoptrigger on client %d, start_mask %lx\n", client, glbl_fifo->start_mask);
          }
      }
    }
  }
  else   // !start_in
  {
    pclient->slope = TRUE;                                // P4.24

    if(pclient->cmd_trigfifo == CMDFIFO_FILLNLB)
    {
      pclient->vlbready = FALSE;
      pclient->cmd_trigfifo = CMDFIFO_ENDNLB;             // stoptrigger received

      if(pclient->trg_mode != TRG_SLAVE)                  // P4.36
        calc_trigger(client, TRG_START, TRUE);            // initialize start trigger
      //printk("stoptrigger received on client %d, start_in %lx\n", client, glbl_fifo->start_in);
    }

    if(!pclient->waitready || (!(glbl_fifo->ready_in & bit_field[pclient->trg_slot]) && pclient->vlbready))  // 4.03
    {
      pclient->waittrig = TRUE;
      if(pclient->trg_mode != TRG_SLAVE)
        if(calc_trigger(client, TRG_START, FALSE))
        {
          glbl_fifo->start_mask |= bit_field[pclient->trg_slot];         // starttrigger occured
          //printk("starttrigger on client %d, start_mask %lx\n", client, glbl_fifo->start_mask);
        }
    }
  }
}


// generate a header for a fifo data buffer
S_HEADER *generate_header(S_FIFO *pfifo, INT32 type, INT32 mode)
{
  S_HEADER *pheader, *pheader_new;
  INT16    care;
  INT32    thisbuf;
  INT32    precount;
  INT32    new_size;
  INT32    mvb_save;

  pheader = (S_HEADER *)(fifo_data + pfifo->mvb_wrt);

  if(mode >= GEN_NEXT)
  {
    if(!(pheader->status & BF_FIFOSTAT_VLBNLB))  // VLB Buffer
    {
      precount = pheader->pre_length;

      if(pheader->status & BF_FIFOSTAT_FULL)
        pfifo->mw_cnt += pfifo->vlbsize;
      else                                       // buffer is not full (has to be shortened)app
      {
        pheader->end = pfifo->wrt_ptr;
        pheader->pre_length = pheader->end - HEADSIZE;
        pfifo->mw_cnt += pheader->pre_length;
      }

      if(pfifo->wrt_ptr == pheader->end)         // begin of VLB oldest data line
        pheader->start = pheader->end - pheader->pre_length;
      else
        pheader->start = pfifo->wrt_ptr;

      pfifo->nlbcount = pfifo->nlblength;        // initialize
    }
    else                                         // NLB Buffer
    {
      if(pfifo->fifo_mode < IDS_CONT_NOOWR)
        precount = pheader->pre_length + pheader->end - pheader->start;
      else
        precount = 0;                            // not for continious buffers

      if(pfifo->nlbcount >= (pheader->end - pheader->start))
        pfifo->nlbcount -= (pheader->end - pheader->start);
      else
        pfifo->nlbcount = 0;                   // this will avoid underflows on nlbcount
    }

    switch(type)
    {
      case BUF_TYPE_VLB:
        new_size = pfifo->vlbsize;
        break;

      case BUF_TYPE_NLB:
        new_size = pfifo->nlbsize;
        break;

      default:
        new_size = 0;
    }

    mvb_save = pfifo->mvb_wrt;

    if(pfifo->mvb_fst > pfifo->mvb_wrt)
      care = TRUE;
    else
      care = FALSE;

    thisbuf = pheader->end;

    if(pfifo->mvb_wrt + thisbuf + new_size + HEADSIZE > pfifo->mvb_end)
    {                                                     // end of fifo buffer reached
      if(care)
      {
        pfifo->mvb_wrt = mvb_save;                        // restore it
        printk("1out of mem: %ld %ld %ld %ld %ld %ld %ld %ld\n", pfifo->mvb_wrt, pfifo->mvb_fst, pfifo->wrt_ptr, pfifo->fst_ptr, type, mode, thisbuf, new_size);
        return(NULL);
      }
      else
      {
        //printk("rept buffer %p %ld %ld : %ld %ld %ld\n", pfifo, pfifo->mvb_wrt, pfifo->mvb_fst, thisbuf, new_size, type);
        pfifo->mvb_wrt = pfifo->mvb_bgn;                  // buffer repeat from begin
        // P4.37 thisbuf = 0;

        if(pfifo->mvb_fst >= pfifo->mvb_wrt)
          care = TRUE;
	else
	  care = FALSE;
      }
    }
    else                                                  // end not reached
    {
      pfifo->mvb_wrt = pfifo->mvb_wrt + pheader->end;     // switch to next buffer
      // thisbuf = 0; // P4.37
    }

    if(care)
    {
      if(pfifo->mvb_wrt /*+ thisbuf P4.37*/ + new_size + HEADSIZE > pfifo->mvb_fst) // buffer full?
      {
        printk("2out of mem: %ld %ld %ld %ld %ld %ld %ld %ld\n", pfifo->mvb_wrt, pfifo->mvb_fst, pfifo->wrt_ptr, pfifo->fst_ptr, type, mode, /*P4.37thisbuf*/mvb_save, new_size);
	pfifo->mvb_wrt = mvb_save;                        // restore it
        return(NULL);
      }
    }

    pheader->next = pfifo->mvb_wrt;
    pheader_new = (S_HEADER *)(fifo_data + pheader->next);
    pheader->status |= BF_FIFOSTAT_READY;                 // buffer is ready
    pheader->status |= BF_FIFOSTAT_FULL;                  // buffer is now full
    pheader->status |= BF_FIFOSTAT_FOLLOW;                // and is followed by another buffer
  }
  else // generate initial buffer
  {
    pheader_new = pheader;
    precount = 0;
  }

  pfifo->wrt_ptr = HEADSIZE;            // initialize writepointer for new buffer
  pheader_new->start = HEADSIZE;        // the begin of the buffer
  pheader_new->next = 0;

  switch(type)
  {
    case BUF_TYPE_VLB:
      pheader_new->status = 0;
      pheader_new->pre_length = pfifo->vlbsize;
      pheader_new->end = pfifo->vlbsize + HEADSIZE;
      break;

    case BUF_TYPE_NLB:
      pheader_new->status = 0;
      pheader_new->status |= BF_FIFOSTAT_VLBNLB;
      pheader_new->pre_length = precount;
      pheader_new->end = HEADSIZE;
      break;
  }

  switch(mode)
  {
    case GEN_ACT:  // initial buffer
      pheader_new->status |= BF_FIFOSTAT_INITIAL;
      break;

    case GEN_LAST:
      pheader_new->status |= BF_FIFOSTAT_LAST;
      break;
  }

  return(pheader_new);
}

// copy data from ga12 data_ram to fifo_ram
// assumes that odd adresses only accompany with 2 byte formats
// otherwise it copies with rep_movs
INT32 copy_ga12_data(UINT32 srcind, UINT32 destind, INT32 count, INT32 format)
{
  UINT32  next_srcind;                            // using nextpage mechanism

  if(count == 0)  // nothing to copy
    return(0);

//   #ifdef SHOWBIT_DEBUG
//     outb(inb(0x378) | 1, 0x378);
//     ga12_ram->OUTP |= 0x01;
//   #endif

  if(glbl_fifo->ga12_cntrl == GA12VER_0)          // DMA isn't woking in this version
  //if(1) // @@@ CP22Test
  {
    next_srcind = (srcind+next_page_b) & ~0x00000003L; //
    if(format == 4)                               // 4 byter
      rep_movs(fifo_data + destind, (INT8*)ga12_ram->data_ram + next_page_b + srcind, count);
    else
    {
      for(; count > 0;count -= 2)
      {
        *(INT16*)(fifo_data + destind) = *(INT16*)((INT8*)ga12_ram->data_ram + next_srcind + 2);
        destind += 2; next_srcind += 4;
      }
    }
  }
  else
  {
    wait_dma_ready();
    next_srcind = (srcind+next_page_b) & ~0x00000003L; //

    if(format == 2)                               // 2 byter
    {
      if(destind & 0x00000002L)                   // odd start adress
      {
        *(INT16*)(fifo_data + destind) = *(INT16*)((INT8*)ga12_ram->data_ram + next_srcind + 2);
        destind += 2; next_srcind += 4; count -= 2;
      }
      if(count & ~0x00000003)                     // only if count>>2 not zero
      {
        ga12_ram->DMA_WrSrcAdr = next_srcind | 0x00000001L; // 2 bytewise
        ga12_ram->DMA_WrDestAdr = destind;
        ga12_ram->DMA_WrCnt = count >> 2;         // must not be zero
      }
    }
    else
    {
      if(destind & 0x00000002L)                   // odd start adress
      {
        rep_movs(fifo_data + destind, (INT8*)ga12_ram->data_ram + next_srcind, count);
      }
      else                                        // only if count>>2 not zero
      {
        ga12_ram->DMA_WrSrcAdr = next_srcind;     // 4 bytewise
        ga12_ram->DMA_WrDestAdr = destind;
        ga12_ram->DMA_WrCnt = count >> 2;         // may not be zero
      }
    }

    if(format == 2)
    {
      if(count & 0x00000002L)                     // count not super even
      {
        wait_dma_ready();
        count &= ~0x00000003L;
        next_srcind += 2*count; destind += count; // jump over the even block
        *(INT16*)(fifo_data + destind) = *(INT16*)((INT8*)ga12_ram->data_ram + next_srcind + 2);
      }
    }
  }

//   #ifdef SHOWBIT_DEBUG
//     outb(inb(0x378) & ~1, 0x378);
//     ga12_ram->OUTP &= ~0x01;
//   #endif

  return(0);
}

// generate time channels
void copy_time_chans(UINT32 destind, INT32 offs, S_FIFO *pfifo)
{
  UINT32 tick, tick2, srcind;

  switch(pfifo->tcs_format)
  {
    case IDS_TIME_HBM_64: // pfifo->output_size == 4
      //tick = timetick1 + offs*MAX_LINE_PP*TIMEINC/pfifo->linepp;
      tick = timetick1 + offs*glbl_fifo->timeinc/pfifo->linepp;
      tick2 = timetick2;
      if(tick & 0x80000000L) // we got an overflow
      {
        tick &= ~0x80000000L;  // only clear the overflow bit 31
        tick2 += 0x100L;
      }
      rep_movs(fifo_data + destind, &tick, 4);
      rep_movs(fifo_data + destind + 4, &tick2, 4);
      break;

    case IDS_TIME_HBM_32: // pfifo->output_size == 2
      //tick = timetick1 + offs*MAX_LINE_PP*TIMEINC/pfifo->linepp;
      tick = timetick1 + offs*glbl_fifo->timeinc/pfifo->linepp;
      tick2 = timetick2;
      if(tick & 0x80000000L) // we got an overflow
      {
        tick &= ~0x80000000L;  // only clear the overflow bit 31
        tick2 += 0x100L;
      }
      tick >>= 8;
      tick |= (tick2 << 15) & 0x7F800000L;
      rep_movs(fifo_data + destind, &tick, 4);
      break;

    case IDS_TIME_NTP:
      tick = tv.tv_usec + offs*MAX_LINE_PP*52/pfifo->linepp;
      rep_movs(fifo_data + destind, &tv.tv_sec, sizeof(tv.tv_sec));   // seconds
      rep_movs(fifo_data + destind + sizeof(tv.tv_sec), &tick, sizeof(tick)); // useconds
      break;

#ifdef CP42
    case IDS_TIME_USB:
      rep_movs(fifo_data + destind, &usb_frame_counter, sizeof(INT32));
      break;
#endif

    case IDS_TIME_IRIG:
      srcind = pfifo->ga12_data_offs + (offs+1) * pfifo->ga12_data_len - 2*sizeof(INT32);
      copy_ga12_data(srcind, destind, 2*sizeof(INT32), sizeof(INT32));
      break;
  }
}

INT32 copy_avr_data(INT8 *dest, S_FIFO *pfifo)
{
  INT32 i, cnt;
  INT8  *ssrc;

  ssrc = (INT8*)ga12_ram->data_ram + next_page_b + pfifo->ga12_data_offs;

  wait_dma_ready();

  if(pfifo->output_size == 2)
  {
    for(i=cnt=0; i<pfifo->pagesize; i+=2, cnt++) // the first synchr. block
    {
      copy_avr(dest+i, ssrc + (i<<1)+2, pfifo->avrblk+cnt, pfifo->avrdiv, 2);
    }
    dest += i;
    ssrc += pfifo->assrcbgn + pfifo->srcbgns;

    for(i=0; i<pfifo->pagesizea; i+=2, cnt++)    // the asynch-synch block
    {
      copy_avr(dest+i, (INT8*)pfifo->assblk+i, pfifo->avrblk+cnt, pfifo->avrdiv, 2);
    }
    dest += i;

    for(i=0; i<pfifo->pagesizes; i+=2, cnt++)    // the second synchr. block
    {
      copy_avr(dest+i, ssrc + (i<<1)+2, pfifo->avrblk+cnt, pfifo->avrdiv, 2);
    }
  }
  else
  {
    for(i=cnt=0; i<pfifo->pagesize; i+=4, cnt++) // the first synchr. block
    {
      copy_avr(dest+i, ssrc + i, pfifo->avrblk+cnt, pfifo->avrdiv, 4);
    }
    dest += i;
    ssrc += pfifo->assrcbgn + pfifo->srcbgns;

    for(i=0; i<pfifo->pagesizea; i+=4, cnt++)    // the asynch-synch block
    {
      copy_avr(dest+i, (INT8*)pfifo->assblk+i, pfifo->avrblk+cnt, pfifo->avrdiv, 4);
    }
    dest += i;

    for(i=0; i<pfifo->pagesizes; i+=4, cnt++)    // the second synchr. block
    {
      copy_avr(dest+i, ssrc + i, pfifo->avrblk+cnt, pfifo->avrdiv, 4);
    }
  }

  return 0;
}

int sum_avr_data(S_FIFO *pfifo)
{
  int i, cnt;
  INT8  *ssrc;

  ssrc = (INT8*)ga12_ram->data_ram + next_page_b + pfifo->ga12_data_offs;

  wait_dma_ready();

  if(pfifo->output_size == 2)
  {
    for(i=cnt=0; i<pfifo->pagesize; i+=2, cnt++) // the first synchr. block
    {
      sum_avr(ssrc + (i<<1)+2, pfifo->avrblk+cnt, 2);
    }
    ssrc += pfifo->assrcbgn + pfifo->srcbgns;

    for(i=0; i<pfifo->pagesizea; i+=2, cnt++)    // the asynch-synch block
    {
      sum_avr((INT8*)pfifo->assblk+i, pfifo->avrblk+cnt, 2);
    }

    for(i=0; i<pfifo->pagesizes; i+=2, cnt++)    // the second synchr. block
    {
      sum_avr(ssrc + (i<<1)+2, pfifo->avrblk+cnt, 2);
    }
  }
  else
  {
    for(i=cnt=0; i<pfifo->pagesize; i+=4, cnt++) // the first synchr. block
    {
      sum_avr(ssrc + i, pfifo->avrblk+cnt, 4);
    }
    ssrc += pfifo->assrcbgn + pfifo->srcbgns;

    for(i=0; i<pfifo->pagesizea; i+=4, cnt++)    // the asynch-synch block
    {
      sum_avr((INT8*)pfifo->assblk+i, pfifo->avrblk+cnt,4);
    }

    for(i=0; i<pfifo->pagesizes; i+=4, cnt++)    // the second synchr. block
    {
      sum_avr(ssrc + i, pfifo->avrblk+cnt, 4);
    }
  }
  return 0;
}

int init_avr_data(S_FIFO *pfifo)
{
  int i, cnt;
  INT8  *ssrc;
  INT32 value;

  ssrc = (INT8*)ga12_ram->data_ram + next_page_b + pfifo->ga12_data_offs;

  wait_dma_ready();

  if(pfifo->output_size == 2)
  {
    for(i=cnt=0; i<pfifo->pagesize; i+=2, cnt++) // the first synchr. block
    {
      value = (INT32)*(INT16*)(ssrc + (i<<1)+2) * pfifo->avrdiv;
      *(INT32*)(pfifo->avrblk+cnt) = value;
    }
    ssrc += pfifo->assrcbgn + pfifo->srcbgns;

    for(i=0; i<pfifo->pagesizea; i+=2, cnt++)    // the asynch-synch block
    {
      value = (INT32)*(INT16*)((INT8*)pfifo->assblk+i) * pfifo->avrdiv;
      *(INT32*)(pfifo->avrblk+cnt) = value;
    }

    for(i=0; i<pfifo->pagesizes; i+=2, cnt++)    // the second synchr. block
    {
      value = (INT32)*(INT16*)(ssrc + (i<<1)+2) * pfifo->avrdiv;
      *(INT32*)(pfifo->avrblk+cnt) = value;
    }
  }
  else
  {
    for(i=cnt=0; i<pfifo->pagesize; i+=4, cnt++) // the first synchr. block
    {
      value = *(INT32*)(ssrc+i) >> 10;
      value *= pfifo->avrdiv;
      *(INT32*)(pfifo->avrblk+cnt) = value;
    }
    ssrc += pfifo->assrcbgn + pfifo->srcbgns;

    for(i=0; i<pfifo->pagesizea; i+=4, cnt++)    // the asynch-synch block
    {
      value = *(INT32*)((INT8*)pfifo->assblk+i) >> 10;
      value *= pfifo->avrdiv;
      *(INT32*)(pfifo->avrblk+cnt) = value;
    }

    for(i=0; i<pfifo->pagesizes; i+=4, cnt++)    // the second synchr. block
    {
      value = *(INT32*)(ssrc+i) >> 10;
      value *= pfifo->avrdiv;
      *(INT32*)(pfifo->avrblk+cnt) = value;
    }
  }
  return 0;
}

// fill one line into the VLB buffer
INT32 fill_vlb(S_FIFO *pfifo)
{
  S_HEADER *pheader = (S_HEADER *)(fifo_data + pfifo->mvb_wrt);
  UINT32 src, dest, count, rcount;
  INT32  ret = FILL_NOVAL;
  INT16  loop;


// #ifdef SHOWBIT_DEBUG
//  ga12_ram->OUTP |= 0x02;
// #endif

  switch(pfifo->link_mode)
  {
    case 2400:
      if(pfifo->fifo_type & BF_AVERAGING)
      {
        if(pfifo->ratecount < pfifo->rateact) // sum data into buffer
        {
          if(pfifo->avrmrcount >= pfifo->avrmract)
          {
            pfifo->avrmrcount = 1;
            sum_avr_data(pfifo);
          }
          else
            pfifo->avrmrcount++;

          pfifo->ratecount += pfifo->rateinc;

          if(pfifo->ratecount >= pfifo->rateact)  // ready detection on rates < 2.4 kHz
          {
            if((pfifo->wrt_ptr + pfifo->mvlsize) >= pheader->end) // will be filled up in the next NMI
              return(FILL_READYV);
          }
          return(FILL_NOVAL);             // nothing todo for this time
        }
        else
        {
          // mov data to fifo
          ret = FILL_OK;
          pfifo->ratecount = pfifo->rateinc;
          pfifo->avrmrcount = 1;

          count = pfifo->mvlsize;

          if((pfifo->wrt_ptr + count) > pheader->end)
          {
            pfifo->wrt_ptr -= pheader->pre_length;   // buffer repping
          }

          if((pfifo->wrt_ptr + count) >= pheader->end)
          {
            pheader->status |= BF_FIFOSTAT_FULL;     // waiting for trigger
            ret = FILL_FULL;
          }
          else if((pfifo->wrt_ptr + 2*count) >= pheader->end)
            if(pfifo->rateinc == pfifo->rateact)     // ready detection only at 2.4 kHz
              ret = FILL_READY;

          dest = pfifo->mvb_wrt + pfifo->wrt_ptr;
          src = pfifo->ga12_data_offs;
          count = pfifo->pagesize+pfifo->pagesizea+pfifo->pagesizes;
          copy_avr_data(fifo_data + dest, pfifo);  // the asyncsync block and the following sync block

          if(pfifo->fifo_type & BF_TIMECHANS)  // timechannels active
            copy_time_chans(dest+count, 0, pfifo);

          pfifo->wrt_ptr += pfifo->mvlsize;    // @@@todo mvlsize
        }
      }
      else  // not averaging
      {
        if(pfifo->ratecount < pfifo->rateact)
        {
          pfifo->ratecount += pfifo->rateinc;

          if(pfifo->ratecount >= pfifo->rateact)  // ready detection on rates < 2.4 kHz
          {
            if((pfifo->wrt_ptr + pfifo->mvlsize) >= pheader->end) // will be filled up in the next NMI
              return(FILL_READYV);
          }
          return(FILL_NOVAL);                   // nothing todo for this time
        }
        else
        {
          ret = FILL_OK;
        }

        pfifo->ratecount = pfifo->rateinc;
        count = pfifo->mvlsize;

        if((pfifo->wrt_ptr + count) > pheader->end)
        {
          pfifo->wrt_ptr -= pheader->pre_length;   // buffer repping
        }

        if((pfifo->wrt_ptr + count) >= pheader->end)
        {
          pheader->status |= BF_FIFOSTAT_FULL;     // waiting for trigger
          ret = FILL_FULL;
        }
        else if((pfifo->wrt_ptr + 2*count) >= pheader->end)
          if(pfifo->rateinc == pfifo->rateact)     // ready detection only at 2.4 kHz
            ret = FILL_READY;

        dest = pfifo->mvb_wrt + pfifo->wrt_ptr;
        src = pfifo->ga12_data_offs;
        count = pfifo->pagesize;

        copy_ga12_data(src, dest, count, pfifo->output_size);

        if(pfifo->fifo_type & BF_ASYNCSYNC)
        {
          dest = dest+count;
          count = pfifo->pagesizea;
          rep_movs(fifo_data + dest, (INT8*)pfifo->assblk, count);  // the asyncsync block and the following sync block
          dest = dest + count;
          count = pfifo->pagesizes;
          src = src + pfifo->assrcbgn + pfifo->srcbgns;
          copy_ga12_data(src, dest, count, pfifo->output_size);
        }

        if(pfifo->fifo_type & BF_TIMECHANS)  // timechannels active
          copy_time_chans(dest+count, 0, pfifo);

        pfifo->wrt_ptr += pfifo->mvlsize;        // @@@ todo mvlsize
      }
      break;

    case 19200:
    case 9600:
    case 4800:
      for(loop=0; loop<pfifo->linepp ;loop++)
      {
        if(pfifo->ratecount < pfifo->rateact)
        {
          pfifo->ratecount += pfifo->rateinc;
          continue;                    // nothing todo for this time
        }
        else if(ret == FILL_NOVAL)
          ret = FILL_OK;

        pfifo->ratecount = pfifo->rateinc;

        count = pfifo->mvlsize;
        rcount = 2 * count * pfifo->linepp*pfifo->rateinc/pfifo->rateact;

        if((pfifo->wrt_ptr + count) > pheader->end)
        {
          pfifo->wrt_ptr -= pheader->pre_length;   // buffer repping
        }

        if((pfifo->wrt_ptr + count) >= pheader->end)
        {
          pheader->status |= BF_FIFOSTAT_FULL;     // waiting for trigger
          ret = FILL_FULL;
        }
        else if((pfifo->wrt_ptr + rcount) >= pheader->end)
          ret = FILL_READY;

        dest = pfifo->mvb_wrt + pfifo->wrt_ptr;
        src = pfifo->ga12_data_offs + loop*pfifo->ga12_data_len;
        count = pfifo->pagesize;

        copy_ga12_data(src, dest, count, pfifo->output_size);

        if(pfifo->fifo_type & BF_ASYNCSYNC)
        {
          dest = dest+count;
          count = pfifo->pagesizea;
          rep_movs(fifo_data + dest, (INT8*)pfifo->assblk, count);  // the asyncsync block and the following sync block
          dest = dest + count;
          count = pfifo->pagesizes;
          src = src + pfifo->assrcbgn + pfifo->srcbgns;
          copy_ga12_data(src, dest, count, pfifo->output_size);
        }

        if(pfifo->fifo_type & BF_TIMECHANS)  // timechannels active
          copy_time_chans(dest+count, loop, pfifo);

        pfifo->wrt_ptr += pfifo->mvlsize;    // @@@ todo mvlsize
      }
      break;
  }

  if(ret != FILL_NOVAL)
    rt_wakeup = TRUE;

//  ga12_ram->OUTP &= ~0x02;

  return(ret);
}


// fill one line into the NLB buffer
INT32 fill_nlb(S_FIFO *pfifo)
{
  S_HEADER *pheader = (S_HEADER *)(fifo_data + pfifo->mvb_wrt);
  UINT32 src, dest, count;
  INT32  ret = FILL_NOVAL;
  INT16  loop;

  switch(pfifo->link_mode)
  {
    case 2400:
      if(pfifo->fifo_type & BF_AVERAGING)
      {
        if(pfifo->ratecount < pfifo->rateact)
        {
          if(pfifo->avrmrcount >= pfifo->avrmract)
          {
            pfifo->avrmrcount = 1;
            sum_avr_data(pfifo);
          }
          else
            pfifo->avrmrcount++;

          pfifo->ratecount += pfifo->rateinc;
          return(FILL_NOVAL);             // nothing todo for this time
        }
        else
        {
          // mov data to fifo
          ret = FILL_OK;
          pfifo->ratecount = pfifo->rateinc;
          pfifo->avrmrcount = 1;

          dest = pfifo->mvb_wrt + pfifo->wrt_ptr;
          src = pfifo->ga12_data_offs;
          count = pfifo->pagesize+pfifo->pagesizea+pfifo->pagesizes;
          copy_avr_data(fifo_data + dest, pfifo);  // the asyncsync block and the following sync block

          if(pfifo->fifo_type & BF_TIMECHANS)  // timechannels active
            copy_time_chans(dest+count, 0, pfifo);

          count = pfifo->mvlsize;
          pfifo->wrt_ptr += count;  // @@@todo mvlsize
          pheader->end += count;
          pfifo->mw_cnt += count;

          if(pfifo->nlbsize > pfifo->nlbcount)
            count = pfifo->nlbcount;
          else
            count = pfifo->nlbsize;

          if((pheader->end - pheader->start) >= count)
          {
            pheader->status |= BF_FIFOSTAT_FULL;     // measurement end
            ret = FILL_FULL;
          }
        }
      }
      else // !averaging
      {
        if(pfifo->ratecount < pfifo->rateact)
        {
          pfifo->ratecount += pfifo->rateinc;
          return(FILL_NOVAL);             // nothing todo for this time
        }
        else
          ret = FILL_OK;

        pfifo->ratecount = pfifo->rateinc;

        dest = pfifo->mvb_wrt + pfifo->wrt_ptr;
        src = pfifo->ga12_data_offs;
        count = pfifo->pagesize;

        copy_ga12_data(src, dest, count, pfifo->output_size);

        if(pfifo->fifo_type & BF_ASYNCSYNC)
        {
          dest = dest+count;
          count = pfifo->pagesizea;
          rep_movs(fifo_data + dest, (INT8*)pfifo->assblk, count);  // the asyncsync block and the following sync block
          dest = dest + count;
          count = pfifo->pagesizes;
          src = src + pfifo->assrcbgn + pfifo->srcbgns;
          copy_ga12_data(src, dest, count, pfifo->output_size);
        }

        if(pfifo->fifo_type & BF_TIMECHANS)  // timechannels active
          copy_time_chans(dest+count, 0, pfifo);

        count = pfifo->mvlsize;
        pfifo->wrt_ptr += count;  // @@@todo mvlsize
        pheader->end += count;
        pfifo->mw_cnt += count;

        if(pfifo->nlbsize > pfifo->nlbcount)
          count = pfifo->nlbcount;
        else
          count = pfifo->nlbsize;

        if((pheader->end - pheader->start) >= count)
        {
          pheader->status |= BF_FIFOSTAT_FULL;     // measurement end
          ret = FILL_FULL;
        }
      }
      break;

    case 19200:
    case 9600:
    case 4800:
      for(loop=0; loop<pfifo->linepp; loop++)
      {
        if(pfifo->ratecount < pfifo->rateact)
        {
          pfifo->ratecount += pfifo->rateinc;
          continue;                   // nothing todo for this time
        }
        else
          ret = FILL_OK;

        pfifo->ratecount = pfifo->rateinc;

        dest = pfifo->mvb_wrt + pfifo->wrt_ptr;
        //src = pfifo->ga12_data_offs + loop*pfifo->pagesize*4/pfifo->output_size; // ups!!! wasn das?
        src = pfifo->ga12_data_offs + loop*pfifo->ga12_data_len;
        count = pfifo->pagesize;

        copy_ga12_data(src, dest, count, pfifo->output_size);

        if(pfifo->fifo_type & BF_ASYNCSYNC)
        {
          dest = dest+count;
          count = pfifo->pagesizea;
          rep_movs(fifo_data + dest, (INT8*)pfifo->assblk, count);  // the asyncsync block and the following sync block
          dest = dest + count;
          count = pfifo->pagesizes;
          src = src + pfifo->assrcbgn + pfifo->srcbgns;
          copy_ga12_data(src, dest, count, pfifo->output_size);
        }

        if(pfifo->fifo_type & BF_TIMECHANS)  // timechannels active
          copy_time_chans(dest+count, loop, pfifo);

        count = pfifo->mvlsize;
        pfifo->wrt_ptr += count;  // @@@todo mvlsize
        pheader->end += count;
        pfifo->mw_cnt += count;

        if(pfifo->nlbsize > pfifo->nlbcount)
          count = pfifo->nlbcount;
        else
          count = pfifo->nlbsize;

        if((pheader->end - pheader->start) >= count)
        {
          pheader->status |= BF_FIFOSTAT_FULL;     // measurement end
          ret = FILL_FULL;
        }
      }
      break;
  }

  if(ret != FILL_NOVAL)
    rt_wakeup = TRUE;

  return(ret);
}


INT32 fill_synca_data(S_FIFO *pfifo)
{
  INT32  value;
  INT32  volatile *psrc;
  INT16  tel, index;
  UINT8  chan, subchan;

  psrc = (INT32 volatile *)((INT8*)ga12_ram->data_ram + next_page_b + pfifo->ga12_data_offs + pfifo->assrcbgn);

  wait_dma_ready();

  if (pfifo->output_size == 4)
  {
	  for(tel=0; tel<pfifo->aslinepp; tel++)
	  {
	    value = *psrc;			// read bytes 0..3 from struct AsynchMsg into 1 long: Head, Typ, Kanal, SubChan
	    if(!(value & 0x80)) 	// new telegram	
	    {
	      chan = (UINT8)(value >> 16)-1;
	      if(chan >= MAX_VERADR) continue;		//chan = 0..MAX_VERADR-1;
	      subchan = (UINT8)(value >> 24)-1;
	      if(subchan >= MAX_SUBADR) continue;	//subchan = 0..MAX_SUBADR-1;
	      // look up index from HashTable
	      index = pfifo->asstable[chan*MAX_SUBADR + subchan];
	      // new 5.1.2010: Typ Bit0 = 0x01 for double async message
	      subchan = (UINT8)(value >> 8);		// get Typ
	      // get data
	      value = *(psrc+3); // data is in the last 4byte

	      // store the data
	      //printk("%d, %d, %d, %d, %lx\n", chan, subchan, index, tel, value);
          *((INT32*)pfifo->assblk + index) = value;

	      // new 5.1.2010: Typ Bit0 = 0x01 for double async message
              // warning: the measured values must come from different sub channels.
              // Only one value is kept in pfifo->assblk. The first one would be overwritten by the second one.
	      if ( subchan & 1 )			// Typ Bit 0: 2nd Data in "TimeStamp"
		  {
		      subchan = *((INT8  volatile *)psrc+6) - 1;// 2nd Subchan is in 1st byte of Timestamp
		      if(subchan >= MAX_SUBADR) continue;		//subchan = MAX_SUBADR-1;
		      index = pfifo->asstable[chan*MAX_SUBADR + subchan];
		      value = *(psrc+2); 						// data is in the last 4byte of Timestamp
		      // store the data
		      //printk("%d, %d, %d, %d, %lx\n", chan, subchan, index, tel, value);
	          *((INT32*)pfifo->assblk + index) = value;
		  }

	    }
	    psrc += ASYNCH_TELLEN;
	  }


  }
  else if (pfifo->output_size == 2)
  {
	  for(tel=0; tel<pfifo->aslinepp; tel++)
	  {
	    value = *psrc;			// read bytes 0..3 from struct AsynchMsg into 1 long: Head, Typ, Kanal, SubChan
	    if(!(value & 0x80)) 	// new telegram	
	    {
	      chan = (UINT8)(value >> 16)-1;
	      if(chan >= MAX_VERADR) continue;		//chan = 0..MAX_VERADR-1;
	      subchan = (UINT8)(value >> 24)-1;
	      if(subchan >= MAX_SUBADR) continue;	//subchan = 0..MAX_SUBADR-1;
	      // look up index from HashTable
	      index = pfifo->asstable[chan*MAX_SUBADR + subchan];
	      // new 5.1.2010: Typ Bit0 = 0x01 for double async message
	      subchan = (UINT8)(value >> 8);		// get Typ
	      // get data
	      value = *(psrc+3); // data is in the last 4byte

	      // store the data
	      //printk("%d, %d, %d, %d, %lx\n", chan, subchan, index, tel, value);
          *((INT16*)pfifo->assblk + index) = (INT16)(value >> 16);

	      // new 5.1.2010: Typ Bit0 = 0x01 for double async message
	      if ( subchan & 1 )			// Typ Bit 0: 2nd Data in "TimeStamp"
		  {
		      subchan = *((INT8  volatile *)psrc+6) - 1;// 2nd Subchan is in 1st byte of Timestamp
		      if(subchan >= MAX_SUBADR) continue;		//subchan = MAX_SUBADR-1;
		      index = pfifo->asstable[chan*MAX_SUBADR + subchan];
		      value = *(psrc+2); 						// data is in the last 4byte of Timestamp
		      // store the data
		      //printk("%d, %d, %d, %d, %lx\n", chan, subchan, index, tel, value);
	          *((INT16*)pfifo->assblk + index) = (INT16)(value >> 16);
		  }
	    }
	    psrc += ASYNCH_TELLEN;
	  }

  }
  return 0;
}

#ifdef CONFIG_X86_TSC   // only with time stamp counter

void do_nmi_gettimeofday(struct timeval *tv)
{
  static INT32    count;
  struct timeval  tv_s;
  INT32  diff;

 #ifdef CP22
  #error "you must source the right project first"
 #endif

  nmi_gettimeofday(&tv_s);   // get the first time
  diff = tv_s.tv_sec - tv->tv_sec;
  diff = tv_s.tv_usec + (diff * 1000000) - tv->tv_usec; // get the diff in usecs

  if(count && (count<10) && (diff > (NMI_PERIOD+500) || diff < (NMI_PERIOD-500)))// accept only +/-50 usecs
  {
    //printk("xtime inconsistent %ld\n", diff);
    tv->tv_usec += NMI_PERIOD;     // we calculate it
    count++;
  }
  else
  {
    count = 1;
    memcpy(tv, &tv_s, sizeof(tv_s));
  }
}

#endif

#ifdef SHOWBIT_DEBUG
//INT8 remember = 0;
#endif
#ifdef SYNC_TEST
static  UINT32  sync_toggle, sync_toggle_save, sync_state, sync_master_state, sync_zero_count, sync_err_count;
static  UINT8   sync_data_stream[64] = "this is a synchronisation test running!!!!!!!!!!!!";
static  UINT8   sync_recv_stream[70];
static  UINT8   sync_recv_byte;
static  UINT32  sync_master_hzr;
static  UINT32  sync_local_hzr;
static  UINT32  sync_recv_hzr;
#endif

// the realtime interrupt handler
void nmi_handler(void)
{
  INT32         stat_0, inport, result;
  INT16         client, fifo;
  S_FIFO        *pfifo_ctrl;
  S_FIFOCLIENT  *pclient_fifo;
  static int    i=0;

  #ifdef SHOWBIT_DEBUG
  INT8          port = 0;
  #endif
  #ifdef SYNC_TEST
  UINT8  sync_data;
  UINT32 sync_index;
  #endif

  // get the ga12 inport
  inport = ga12_ram->INP;
  if(inport & GA12_INP_PINT)        // page interrupt not active
  {
    //  unsigned char reason = inb(0x61);
    //printk("PINT!\n");
    DISABLE_NMI;

    ENABLE_NMI;                     // must be another NMI source
    return;                         // leave this now
  }

  DISABLE_NMI;

  #ifdef SHOWBIT_DEBUG
  port = inb(0x378) | 0x01;                // debug toggle pp bit
  outb(port, 0x378);
  //ga12_ram->OUTP |= 0x01;
  #endif

  // get status of pageinterrupt and reset the interrupt line
  stat_0 = RESET_PAGEINT;
  glbl_fifo->glbl_status = stat_0;

  // run mod75er detection
  if(stat_0 & STAT_MOD75ER)         // do HZR resync on missing/misplaced 75Hz or Slot75 error
  {
    if(!(stat_0 & STAT_HZRSYENO))   // only if no HZR resync is running
    {
      ga12_ram->HZRCMP0 = GA12_HZR_START_RE;                 // HZR Start value
      ga12_ram->HZRSY_REQ = 0x0L;                            // do HZR sync
      printk("MOD75ER detected\n");
    }
  }

  #ifdef SYNC_TEST
  // run slot75er detection
  if(stat_0 & STAT_SLOT75ER)         // do HZR resync on missing/misplaced 75Hz or Slot75 error
  {
    if(glbl_fifo->synctest & SYNC_SLOT75_ERR)
    {
      if(!(stat_0 & STAT_HZRSYENO))   // only if no HZR resync is running
      {
        ga12_ram->HZRCMP0 = GA12_HZR_START_RE;   // HZR Start value
        ga12_ram->HZRSY_REQ = 0x0L;              // do HZR sync
        ga12_ram->STR1 |= STR1_SLOTERRMODE;      // reset sloterror flag
        ga12_ram->STR1 &= ~STR1_SLOTERRMODE;
        glbl_fifo->sync_err_cnt[SYNC_SLOT75_ERR_NO]++;
      }
    }
  }
  #endif

  // get ready_in and start_in vektors
  glbl_fifo->start_in = ga12_ram->SyStart_IN;
  glbl_fifo->ready_in = ga12_ram->Ready_IN;

  // toggle the active page in ga12 (page0/1 and page2/3 boundary at 32k)
  if(!next_page)
  {
    next_page = 32768;
    next_page_b = 131072;           // offset in bytes
    ga12_ram->STR1 |= STR1_NEXTPAGE_2;
  }
  else
  {
    next_page = next_page_b = 0;
    ga12_ram->STR1 &= ~STR1_NEXTPAGE_MASK;
  }

  #if defined CP42 && defined CONFIG_X86_TSC   // only with time stamp counter
   // generate global timeticks
   do_nmi_gettimeofday(&tv);       // the system time
   memcpy(&glbl_fifo->ntptime, &tv, sizeof(tv));
  #endif

  timetick1 += glbl_fifo->timeinc; // f.e. 76.8 kHz
  if(timetick1 & 0x80000000L)
  {
    timetick1 &= ~0x80000000L;  // only clear the overflow bit 31
    timetick2 += 0x100L;
    //printk("time: %lx %lx\n", timetick1, timetick2);
  }
  glbl_fifo->time1 = timetick1; // save it for application
  glbl_fifo->time2 = timetick2;
  glbl_fifo->usbtime = usb_frame_counter;

 #ifdef SYNC_TEST
  if(glbl_fifo->synctest)
  {
    if(glbl_fifo->start_in & bit_field[SYNC_TOGGLE_BIT])
    {
      if(sync_toggle_save)
      {
        glbl_fifo->syncstatus |= SYNC_STATUS_CLOCK_ERR;        // we have a toggle/clock error
        glbl_fifo->sync_err_cnt[SYNC_STATUS_CLOCK_ERR_NO]++;   // count it
      }
      else
      {
        glbl_fifo->syncstatus &= ~SYNC_STATUS_CLOCK_ERR;
      }

      sync_state++;
      sync_recv_byte >>= 1;                                  // want to receive the next bit

      if(!(glbl_fifo->start_in & bit_field[SYNC_DATA_BIT]))  // 0bit received
      {
        sync_zero_count++;
        if(sync_state > SYNC_CYCLE_BITS)                     // timeout in telegram receive
        {
          glbl_fifo->syncstatus |= SYNC_STATUS_TIMO_ERR;
          glbl_fifo->sync_err_cnt[SYNC_STATUS_TIMO_ERR_NO]++;   // count it
        }
      }
      else                                                   // 1bit received
      {
        sync_recv_byte |= 0x80;

        if(sync_zero_count > 12)                             // reset the statemachine
        {
          sync_recv_hzr = *(UINT32*)&sync_recv_stream[SYNC_DYN_HZR_INDEX];
          glbl_fifo->sync_hzr_diff = sync_local_hzr - sync_recv_hzr - SYNC_HZR_NMI_PERIOD; // get the difference

          if(glbl_fifo->sync_hzr_diff > SYNC_HZR_NMI_PERIOD || glbl_fifo->sync_hzr_diff < -SYNC_HZR_NMI_PERIOD)
          {
            glbl_fifo->syncstatus |= SYNC_STATUS_HZR_ERR;
            glbl_fifo->sync_err_cnt[SYNC_STATUS_HZR_ERR_NO]++;   // count it
          }
          else
          {
            glbl_fifo->syncstatus &= ~SYNC_STATUS_HZR_ERR;
            glbl_fifo->sync_err_cnt[SYNC_STATUS_NO_ERR_NO]++;    // we received the whole telegram OK
          }

          ga12_ram->HZR_STB = 0;                             // strobe HZR for synctest
          sync_local_hzr = ga12_ram->HZR;                    // local hzr
          sync_state = 0;
          glbl_fifo->syncstatus &= ~SYNC_STATUS_TIMO_ERR;    // reset timeout
        }

        sync_zero_count = 0;
      }
      #ifdef SHOWBIT_DEBUG
      //if(sync_recv_byte & 0x80)
      //  port |= 0x10;   // debug toggle pp bit
      //else
      //  port &= ~0x10;   // debug toggle pp bit
      //outb(port, 0x378);
      #endif

      if((sync_state & SYNC_BIT_MASK) == SYNC_BIT_MASK)      // byte is complete
      {
        //printk("byte received %x\n", sync_recv_byte);
        if(!(sync_state & SYNC_ZERO_BIT))
        {
          if(!(sync_state & SYNC_0F_BIT))                      // we should receive 0F
          {
            if(sync_recv_byte != 0x0F)
            {
              glbl_fifo->syncstatus |= SYNC_STATUS_0F_ERR;        // but did not
              glbl_fifo->sync_err_cnt[SYNC_STATUS_0F_ERR_NO]++;   // count it

              #ifdef SHOWBIT_DEBUG
              //port |= 2;   // debug toggle pp bit
              //outb(port, 0x378);
              #endif
              //printk("%x", sync_recv_byte);
            }
            else
              glbl_fifo->syncstatus &= ~SYNC_STATUS_0F_ERR;
          }
          else                                                 // will receive data byte
          {
            sync_index = (sync_state & SYNC_DATA_MASK) >> 4;
            sync_recv_stream[sync_index] = sync_recv_byte;

            if(sync_index < SYNC_STATIC_BYTES)                 // only in the static stream area
            {
              if(sync_recv_stream[sync_index] != sync_data_stream[sync_index])
              {
                glbl_fifo->syncstatus |= SYNC_STATUS_DATA_ERR;      // but did not
                glbl_fifo->sync_err_cnt[SYNC_STATUS_DATA_ERR_NO]++;   // count it

                #ifdef SHOWBIT_DEBUG
                //port |= 4;   // debug toggle pp bit
                //outb(port, 0x378);
                #endif
                //printk("4");
                //printk("received stream %s\n", sync_recv_stream);
                //printk("long %lx\n", *(UINT32*)sync_recv_stream);
              }
              else
                glbl_fifo->syncstatus &= ~SYNC_STATUS_DATA_ERR;
            }
          }
        }
      }
      sync_toggle_save = 1;
    }
    else
    {
      if(!sync_toggle_save)
      {
        glbl_fifo->syncstatus |= SYNC_STATUS_CLOCK_ERR;        // we have a toggle/clock error
        glbl_fifo->sync_err_cnt[SYNC_STATUS_CLOCK_ERR_NO]++;   // count it
      }
      else
        glbl_fifo->syncstatus &= ~SYNC_STATUS_CLOCK_ERR;

      if(glbl_fifo->start_in & bit_field[SYNC_DATA_BIT])  // 0bit should have been received
      {
        glbl_fifo->syncstatus |= SYNC_STATUS_TOGGLE_ERR;
        glbl_fifo->sync_err_cnt[SYNC_STATUS_TOGGLE_ERR_NO]++;   // count it
      }
      else
        glbl_fifo->syncstatus &= ~SYNC_STATUS_TOGGLE_ERR;

      #ifdef SHOWBIT_DEBUG
      //port &= ~0x0E;   // debug toggle pp bit
      //outb(port, 0x378);
      #endif
      sync_toggle_save = 0;
    }

    if(glbl_fifo->syncstatus & glbl_fifo->synctest & ~SYNC_STATUS_HZR_ERR)         // HZR can't solved by local resync
    {
      if(sync_err_count++ > 4800)
      {
        sync_err_count = 0;
        ga12_ram->HZRCMP0 = GA12_HZR_START_RE;                 // HZR Start value
        ga12_ram->HZRSY_REQ = 0x0L;                            // do HZR sync
        printk("Local resynced\n");
      }
    }

    // master code
    if(inport & GA12_INP_MASTER)
    {
      if(!sync_toggle)
      {
        sync_toggle = 1;

        glbl_fifo->start_mask |= bit_field[SYNC_TOGGLE_BIT];

        if(sync_master_state++ >= SYNC_CYCLE_BITS)
        {
          ga12_ram->HZR_STB = 0;                     // strobe HZR for synctest
          sync_master_hzr = ga12_ram->HZR;           // hzr for sending to slaves
          *(UINT32*)&sync_data_stream[SYNC_DYN_HZR_INDEX] = sync_master_hzr;
          sync_master_state = 0;
        }

        glbl_fifo->start_mask &= ~bit_field[SYNC_DATA_BIT];        // reset the bit

        if(sync_master_state & SYNC_ZERO_BIT)
          ; // do nothing
        else if(!(sync_master_state & SYNC_0F_BIT))                // 0F is sent as first byte, so the first 1bit after
        {                                                          // more than 12 0bits resets the statemachine
          if(0x0F & (UINT8)bit_field[(sync_master_state & SYNC_BIT_MASK)])
            glbl_fifo->start_mask |= bit_field[SYNC_DATA_BIT];
        }
        else
        {
          sync_data = sync_data_stream[(sync_master_state & SYNC_DATA_MASK)>>4];
          if(sync_data & (UINT8)bit_field[(sync_master_state & SYNC_BIT_MASK)])
            glbl_fifo->start_mask |= bit_field[SYNC_DATA_BIT];
        }
        #ifdef SHOWBIT_DEBUG
        //if(glbl_fifo->start_mask & bit_field[SYNC_DATA_BIT])
        //  port |= 8;   // debug toggle pp bit
        //else
        //  port &= ~8;   // debug toggle pp bit
        //outb(port, 0x378);
        #endif
      }
      else
      {
        glbl_fifo->start_mask &= ~(bit_field[SYNC_TOGGLE_BIT] | bit_field[SYNC_DATA_BIT]);
        sync_toggle = 0;
      }
      glbl_fifo->syncinfo |= SYNC_INFO_MSTR;        // this device feels as sync master
      ga12_ram->SyStart_MSK = glbl_fifo->start_mask;  // writing it into hardware as soon as possible
    }
    else
    {
      glbl_fifo->start_mask &= ~(bit_field[SYNC_TOGGLE_BIT] | bit_field[SYNC_DATA_BIT]);// slaves have to be quiet on the slots
      glbl_fifo->syncinfo &= ~SYNC_INFO_MSTR;       // this device feels as sync slave
    }
  }
 #endif

  if(glbl_fifo->active)     // to be able to start or stop them all together
  {
    switch(glbl_fifo->cmd_glbl)
    {
      case CMDGLBL_MEASURE:

        for(client=0; client<MAX_EXT_PORTS; client++)
        {
          rt_wakeup = 0;                    // no rt_thread has to run

          if(client_fifo[client].active)
          {
            pclient_fifo = client_fifo + client;

            switch(pclient_fifo->cmd_client)
            {
              case CMDCLIENT_INIT_ASS:
                for(fifo=0; fifo<MAX_FIFO; fifo++)
                {
                  pfifo_ctrl = fifo_ctrl[client] + fifo;

                  if(pfifo_ctrl->fifo_type & BF_ASYNCSYNC)
                  {
                    fill_synca_data(pfifo_ctrl);    // look for async telegrams
                  }
                }
                break;

              case CMDCLIENT_INIT:
                switch(pclient_fifo->client_status)
                {
                  case RT_STAT_OK:
                    set_start(pclient_fifo, TRUE);
                    for(fifo=0; fifo<MAX_FIFO; fifo++)
                    {
                      pfifo_ctrl = fifo_ctrl[client] + fifo;
  
                      if(pfifo_ctrl->fifo_type & BF_ASYNCSYNC)
                      {
                        fill_synca_data(pfifo_ctrl);    // look for async telegrams
                      }
                    }
                    pclient_fifo->client_status = RT_STAT_TRIGINIT;
                    break;

                  case RT_STAT_TRIGINIT:
                    if(get_start(pclient_fifo))
                    {
                      set_start(pclient_fifo, FALSE);

                      for(fifo=0; fifo<MAX_FIFO; fifo++)
                      {
                        pfifo_ctrl = fifo_ctrl[client] + fifo;

                        if(pfifo_ctrl->fifo_type & BF_ASYNCSYNC)
                        {
                          fill_synca_data(pfifo_ctrl);    // look for async telegrams
                        }
                      }

                      for(fifo=0; fifo<MAX_FIFO; fifo++)
                      {
                        if(fifo_ctrl[client][fifo].active)
                        {
                          pfifo_ctrl = fifo_ctrl[client] + fifo;

                          if(pfifo_ctrl->fifo_type & BF_AVERAGING)
                          {
                            init_avr_data(pfifo_ctrl);    // initialize the averaging buffer
                          }
                        }
                      }

                      if(glbl_fifo->timezero_start)
                      {
                        timetick1 = timetick2 = 0;        // poor thing from "MARKETING": don't work for multiclient
                      }
                      else                                // in the other case we use it for the FOKKER stuff
                      {                                   // it's not better than above!
                        //glbl_fifo->timezero_start = timetick2 << 15;
                        //glbl_fifo->timezero_start |= (timetick1 >> 8) & 0x07fffffL;
                        // this wasn't sufficient for multi device systems and PRC8 use by catman
                        // we will use the GA12 internal HZR which counts in 25ns and overruns after 1.8min
                        // see HZR_STB below...
                        ga12_ram->HZR_STB = 0;                     // strobe HZR for MST command P4.24
                        glbl_fifo->timezero_start = ga12_ram->HZR; // sync the TSV command P4.24

                        // Wenn Bremse gezogen ist, wechseln wir in einen Wartezustand
                        if(glbl_fifo->wait_mst)
                        {
                          pclient_fifo->client_status = RT_STAT_WAITMST;
                          break;
                        }
                      }

                      pclient_fifo->cmd_client = CMDCLIENT_MEASURE;
                      pclient_fifo->client_status = RT_STAT_OK;

                      calc_trigger(client, TRG_START, TRUE);    // initialize slopebuffer for dynamic triggers  4.18
                      calc_trigger(client, TRG_MRSTART, TRUE);
                    }
                    break;

                  case RT_STAT_WAITMST:
                    for(fifo=0; fifo<MAX_FIFO; fifo++)
                    {
                      pfifo_ctrl = fifo_ctrl[client] + fifo;

                      if(pfifo_ctrl->fifo_type & BF_ASYNCSYNC)
                      {
                        fill_synca_data(pfifo_ctrl);    // look for async telegrams
                      }
                    }

                    if(!glbl_fifo->wait_mst)
                    {
                      pclient_fifo->cmd_client = CMDCLIENT_MEASURE;
                      pclient_fifo->client_status = RT_STAT_OK;

                      calc_trigger(client, TRG_START, TRUE);    // initialize slopebuffer for dynamic triggers  4.18
                      calc_trigger(client, TRG_MRSTART, TRUE);
                    }
                    break;
                  default: break;
                }
                break;

              case CMDCLIENT_MEASURE:

                trigger(client);                              // calculate trigger

                for(fifo=0; fifo<MAX_FIFO; fifo++)
                {
                  if(fifo_ctrl[client][fifo].active)
                  {
                    pfifo_ctrl = fifo_ctrl[client] + fifo;

                    switch(pfifo_ctrl->fifo_mode)
                    {
                      case IDS_TRIG_OWR:
                      case IDS_TRIG_NOOWR:
                        if(pfifo_ctrl->cmd_fifo != CMDFIFO_NOCMD)
                          pfifo_ctrl->cmd_fifo = pclient_fifo->cmd_trigfifo;
                        break;

                      default: break;
                    }
                  }
                }

                for(fifo=0; fifo<MAX_FIFO; fifo++)
                {
                  if(fifo_ctrl[client][fifo].active)
                  {
                    pfifo_ctrl = fifo_ctrl[client] + fifo;

                    if(pfifo_ctrl->fifo_type & BF_ASYNCSYNC)
                      fill_synca_data(pfifo_ctrl);    // look for async telegrams

                    switch(pfifo_ctrl->fifo_mode)
                    {
                      case IDS_TRIG_OWR:
                      case IDS_TRIG_NOOWR:

                        switch(pfifo_ctrl->cmd_fifo)
                        {
                          case CMDFIFO_INIT:
                            generate_header(pfifo_ctrl, BUF_TYPE_VLB, GEN_ACT);
                            set_ready(pclient_fifo, FALSE);
                            pclient_fifo->cmd_trigfifo = CMDFIFO_FILLVLB;
                            goto FILL_VLB;               // CP32 compatibility

                          case CMDFIFO_GENVLB:
                            GEN_VLB:
                            if(!generate_header(pfifo_ctrl, BUF_TYPE_VLB, GEN_NEXT))
                            {
                              set_start(pclient_fifo, FALSE);
                              pclient_fifo->cmd_trigfifo = CMDFIFO_NOCMD;
                              pclient_fifo->client_status = RT_STAT_MEMOVL;
                              break;
                            }
                            else
                              pclient_fifo->cmd_trigfifo = CMDFIFO_FILLVLB;

                          case CMDFIFO_FILLVLB:
                            FILL_VLB:
                            result=fill_vlb(pfifo_ctrl);
                            if(result >= FILL_READY || result == FILL_READYV)
                            {
                              if(fifo == pclient_fifo->fastestfifo)
                              {
                                set_ready(pclient_fifo, TRUE);
                                pclient_fifo->vlbready = TRUE;
                              }
                            }

                            if(result >= FILL_OK)
                            {
                              if(fifo == pclient_fifo->fastestfifo)
                              {
                                if( pclient_fifo->mrtrig_loop )
                                  pclient_fifo->mrtrig_loop--;
                              }
                            }
                            break;

                          case CMDFIFO_ENDVLB:
                            if(pfifo_ctrl->nlbsize)
                            {
                              pfifo_ctrl->mvb_cnt++;
                              goto GEN_NLB;
                            }
                            else                                      // no NLB (Nachlaufpuffer)
                            {
                              if(pfifo_ctrl->repeatcount < pfifo_ctrl->repeat || !pfifo_ctrl->repeat)
                              {
                                pfifo_ctrl->repeatcount++;

                                if(fifo == pclient_fifo->fastestfifo)
                                {
                                  set_ready(pclient_fifo, FALSE);
                                  set_start(pclient_fifo, FALSE);
                                }
                                goto GEN_VLB;
                              }
                              else // that was it, all repeats are done
                              {
                                generate_header(pfifo_ctrl, BUF_TYPE_NLB, GEN_LAST); // to make the last buffer ready

                                if(fifo == pclient_fifo->fastestfifo)
                                {
                                  set_start(pclient_fifo, FALSE);
                                  pclient_fifo->cmd_trigfifo = CMDFIFO_NOCMD;
                                }
                              }
                            }
                            break;

                          case CMDFIFO_GENNLB:
                            GEN_NLB:
                            if(!generate_header(pfifo_ctrl, BUF_TYPE_NLB, GEN_NEXT))
                            {
                              set_start(pclient_fifo, FALSE);
                              pclient_fifo->client_status = RT_STAT_MEMOVL;
                              pclient_fifo->cmd_trigfifo = CMDFIFO_NOCMD;
                              break;
                            }
                            else
                            {
                              pclient_fifo->cmd_trigfifo = CMDFIFO_FILLNLB;
                              if(fifo == pclient_fifo->fastestfifo)
                              {
                                set_ready(pclient_fifo, FALSE);               // P4.24 set !ready earlier
                              }
                            }

#ifdef WG_MARIN
		        	if ( (INT32)pfifo_ctrl->repeat < 0 )
				{
       					pfifo_ctrl->rateact = pfifo_ctrl->rate1;
					if ( pclient_fifo->trg_mode != TRG_SLAVE )
					{
			      			pclient_fifo->starttrig = IDS_sofort;
					}
					(INT32)pfifo_ctrl->repeat = -(INT32)pfifo_ctrl->repeat;
				}
#endif

                          case CMDFIFO_FILLNLB:
                            if((result=fill_nlb(pfifo_ctrl)) == FILL_FULL)    // look for NLB ready
                            {
                              if(pfifo_ctrl->nlbcount > pfifo_ctrl->nlbsize)  // we have multiple NLBs and this isn't the last
                              {

                                //if(fifo == pclient_fifo->fastestfifo)       // P4.08 bug found by Bernd 18.08.03
                                pclient_fifo->cmd_trigfifo = CMDFIFO_GENNLB;
                                //printk("switch to NLB %d %ld\n", fifo, pfifo_ctrl->nlbcount);
                              }
                              else                                            // NLB is ready
                              {
                                if(fifo == pclient_fifo->fastestfifo)
                                {
                                  //set_ready(pclient_fifo, FALSE);           // P4.24 !ready now earlier see above!
                                  set_start(pclient_fifo, FALSE);
                                  pclient_fifo->nlbready = TRUE;
                                }
                              }
                            }

                            if(result >= FILL_OK)
                            {
                              if((fifo == pclient_fifo->fastestfifo) && pclient_fifo->mrtrig_loop)
                                pclient_fifo->mrtrig_loop--;
                            }
                            break;

                          case CMDFIFO_ENDNLB:

                            if(pfifo_ctrl->repeatcount < pfifo_ctrl->repeat || !pfifo_ctrl->repeat)
                            {
                              pfifo_ctrl->repeatcount++;
                              goto GEN_VLB;
                            }
                            else                                      // we are all ready: that was it
                            {
                              generate_header(pfifo_ctrl, BUF_TYPE_NLB, GEN_LAST); // to make the last buffer ready

                              if(fifo == pclient_fifo->fastestfifo)
                              {
                                set_start(pclient_fifo, FALSE);
                                pclient_fifo->cmd_trigfifo = CMDFIFO_NOCMD;
                              }
                            }

                          case CMDFIFO_NOCMD:
                            pfifo_ctrl->active = FALSE;
                            break;
                        }
                        if(pclient_fifo->cmd_trigfifo == CMDFIFO_NOCMD) // P4.37 overflow detected
                          pfifo_ctrl->cmd_fifo = CMDFIFO_NOCMD;         // halt this fifo!!

                        break;

                      case IDS_CONT_OWR:
                        switch(pfifo_ctrl->cmd_fifo)
                        {
                          case CMDFIFO_INIT:
                            generate_header(pfifo_ctrl, BUF_TYPE_VLB, GEN_ACT);
                            pfifo_ctrl->cmd_fifo = CMDFIFO_FILLVLB;
                            break;

                          case CMDFIFO_FILLVLB:
                            result = fill_vlb(pfifo_ctrl);
                            break;
                        }
                        break;

                      case IDS_CONT_NOOWR:
                        switch(pfifo_ctrl->cmd_fifo)
                        {
                          case CMDFIFO_INIT:
                            generate_header(pfifo_ctrl, BUF_TYPE_NLB, GEN_ACT);
                            pfifo_ctrl->nlbcount = pfifo_ctrl->nlblength;         // we only have NLBs
                            pfifo_ctrl->cmd_fifo = CMDFIFO_FILLNLB;
                            break;

                          case CMDFIFO_GENNLB:
                            CONT_GEN_NLB:
                            if(!generate_header(pfifo_ctrl, BUF_TYPE_NLB, GEN_NEXT))
                            {
                              pfifo_ctrl->fifo_status = RT_STAT_MEMOVL;
                              pfifo_ctrl->cmd_fifo = CMDFIFO_NOCMD;
                            }
                            else
                            {
#ifdef WG_MARIN
			      if ( (INT32)pfifo_ctrl->repeat < 0 )
					(INT32)pfifo_ctrl->repeat = -(INT32)pfifo_ctrl->repeat;
#endif
                              pfifo_ctrl->cmd_fifo = CMDFIFO_FILLNLB;
                            }
                            pfifo_ctrl->nlbcount = pfifo_ctrl->nlblength;    // we only have NLBs
                            break;

                          case CMDFIFO_FILLNLB:
                            if((result=fill_nlb(pfifo_ctrl)) == FILL_FULL)    // look for NLB rea
                            {
                              if(pfifo_ctrl->nlbcount > pfifo_ctrl->nlbsize)  // 4.18 we have multiple and this is not the last
                              {
                                goto CONT_GEN_NLB;
                              }
                              else                                            // NLB is ready
                              {
                                if(pfifo_ctrl->repeatcount < pfifo_ctrl->repeat || !pfifo_ctrl->repeat)
                                {
                                  //pfifo_ctrl->nlbcount = pfifo_ctrl->nlblength; see above 4.18   // we only have NLBs
                                  pfifo_ctrl->repeatcount++;
                                  goto CONT_GEN_NLB;
                                }
                                else                                      // we are all ready: that was it
                                {
                                  generate_header(pfifo_ctrl, BUF_TYPE_NLB, GEN_LAST); // to make the last buffer ready
                                  pfifo_ctrl->cmd_fifo = CMDFIFO_NOCMD;
                                }

                                pfifo_ctrl->mvb_cnt++;
                              }
                            }
                            break;

                          case CMDFIFO_NOCMD:
                            pfifo_ctrl->active = FALSE;
                            break;
                        }

                        break;
                    }
                  }
                } // for (fifo ..

                result = FALSE;
                for(fifo=0; fifo<MAX_FIFO; fifo++)
                {
                  if(fifo_ctrl[client][fifo].active)
                  {
                    result = TRUE;
                    pfifo_ctrl = fifo_ctrl[client] + fifo;

                    switch(pfifo_ctrl->fifo_mode)
                    {
                      case IDS_TRIG_OWR:
                      case IDS_TRIG_NOOWR:
                        if(pfifo_ctrl->cmd_fifo != CMDFIFO_NOCMD)
                          pfifo_ctrl->cmd_fifo = pclient_fifo->cmd_trigfifo;
                        break;

                      default: break;
                    }
                  }
                }
                if(!result)   // clientjob is done
                {
                  glbl_fifo->start_mask &= ~bit_field[pclient_fifo->mrtrg_slot];
                  glbl_fifo->start_mask &= ~bit_field[pclient_fifo->trg_slot];  // reset start condition and set ready condition (v)
                  glbl_fifo->ready_mask &= ~bit_field[pclient_fifo->trg_slot];  // do not forbid measurement of subsets of devices P4.25
                  pclient_fifo->active = FALSE;
                  pclient_fifo->waittrig = FALSE;
                  pclient_fifo->cmd_client = CMDCLIENT_NOCMD; // client RT initialize

                 #ifdef USE_RTNET
                  rt_wakeup = TRUE;     // call it once more
                 #endif
                  //printk("client ready %d\n", client);
                }

                break; // CMDCLIENT_MEASURE

              case CMDCLIENT_NOCMD:
                break;
            }

            if(rt_wakeup)
            {
              if(pclient_fifo->rt_pid)
              {
                ga12_ram->HINT = 1;       // order an IRQ for waking up realtime threads
              }
            }
          }   // if client active
        }     // for client
        break;// case CMDGLBL_MEASURE

      case CMDGLBL_TIMESYNC:
        ga12_ram->HZR_STB = 0;          // strobe HZR
        timetick1 = ga12_ram->data_ram[HZR_DDP*SLOTS_PER_DDP];     // gross
        timetick2 = ga12_ram->data_ram[HZR_DDP*SLOTS_PER_DDP + 1]; // net

        printk("HZR from 1st RD:%08lx,%08lx\n", timetick2, timetick1);

        timetick1 >>= 7;                //   |47______|________|______24|________| |23______|________|_______0|________|
        result = timetick2 & 0x3F00L;   //
        result <<= 17;                  // ||
        timetick1 |= result;            // vv
        timetick2 >>= 6;                //   |_____47_|________|______30|________| |_29_____|________|_______7|________|

        timetick1 &= 0xFFFFFF00L;
        timetick2 &= 0xFFFFFF00L;

        printk("TIMESYNC HZR:%08lx,%08lx ; GA12_HZR:%08lx\n", timetick2, timetick1, ga12_ram->HZR);

        glbl_fifo->cmd_glbl = CMDGLBL_MEASURE;
        break;

      case CMDGLBL_LINKTEST:
        LinkTestNmi();
        break;

      case CMDGLBL_DMATEST:
        printk("DMATEST %d\n", i);
        copy_ga12_data(i, 0, 20, 2);
        i += 1024;
        glbl_fifo->cmd_glbl = CMDGLBL_MEASURE;
        break;

      case CMDGLBL_BREAK:    // to access the running handler
        glbl_fifo->cmd_glbl = CMDGLBL_MEASURE;
        BREAKPOINT;
        break;

      case CMDGLBL_NOCMD:
      default:
        break;
    }
  }

  ga12_ram->SyStart_MSK = glbl_fifo->start_mask;
  ga12_ram->Ready_MSK = glbl_fifo->ready_mask;

  wait_dma_ready();

  ENABLE_NMI;

  #ifdef SHOWBIT_DEBUG
  port &= ~0x01;   // debug toggle pp bit
  outb(port, 0x378);
  //ga12_ram->OUTP &= ~0x01;
  #endif

  return;
}
