// JDrvOs.h ansi_c&windows
// JIDA driver OS specific low level functions
// {G)U(2} 2001.10.11

/****************************************************************************/

#ifndef _JDRVOS_H_
#define _JDRVOS_H_

/****************************************************************************/
// Standard port IO

uchar JosReadPort8(uint port);
ushort JosReadPort16(uint port);
ulong JosReadPort32(uint port);
void JosWritePort8(uint port, uint value);
void JosWritePort16(uint port, uint value);
void JosWritePort32(uint port, ulong value);

/****************************************************************************/
// Video card style indexed IO

void JosWriteIndex8(uint port, uint ind, uint val);
uchar JosReadIndex8(uint port, uint ind);

/****************************************************************************/
// PCI configuration space

ulong JosReadPCI32(ulong fct);
void JosWritePCI32(ulong fct, ulong val);

ulong JosFindPCI(ulong *pIdList);

/****************************************************************************/
// Delay functions

void JosSleepms(ulong ms);
void JosWaitus(ulong us);

/****************************************************************************/
// Memory allocation and mapping

void *JosAllocMem(ulong len);
void JosFreeMem(void *p);

void *JosMapAddress(ulong AddrHigh, ulong AddrLow, ulong AddressSpace, ulong NumberOfBytes);
void JosUnMapAddress(void *base, ulong type, ulong len);

/****************************************************************************/

#endif 

