/***************************************************************************
                          usbcphost.h  -  description
                             -------------------
    begin                : Tue Mar 5 2002
    copyright            : (C) 2002 by Siegfried Wesler, T-V, HBM GmbH
    email                : siegfried.wessler@hbm.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


//#define DEBUG_ON


#ifdef DEBUG_ON
  #define DPRINT(format, a...)  printk(format, ## a)
#else
  #define DPRINT(format, a...)
#endif



/* Version Information */
#define MODULE_NAME "usb_cphost"
#define DRIVER_VERSION "v0.2.4 - 16.01.2003"
#define DRIVER_AUTHOR "Siegfried Wessler, T-V, HBM GmbH, siegfried.wessler@hbm.com"
#define DRIVER_DESC "USB driver for MGCplus (CP42/CP22) access"


/* Define these values to match your device */
#define USB_VENDOR_ID1    0x067D
#define USB_PRODUCT_ID1   0x0101

#define USB_VENDOR_ID2    0x10D1
#define USB_PRODUCT_ID2A  0x0201  // CP22
#define USB_PRODUCT_ID2B  0x0202  // CP42 developer
#define USB_PRODUCT_ID2C  0x0101  // USB-Adapter Ki
#define USB_PRODUCT_ID2D  0x0301  // CP42 official


/* Get a minor range for your devices from the usb maintainer */
#define USB_CPHOST_MINOR_BASE 240

/* we can have up to this number of device plugged in at once.
   USB.c allows max. 16. */
#define MAX_DEVICES   16


/* Until I have an idea how many magic numbers are already used by Linux programmers,
    I simply take these one: 0xA2 */
#define USB_CPHOST_IOC_MAGIC        0xA2
#define USB_CPHOST_IOC_GET_IDSTR    _IOW(USB_CPHOST_IOC_MAGIC, 1, 255)
#define USB_CPHOST_IOC_SET_TIMEOUT  _IOW(USB_CPHOST_IOC_MAGIC, 2, 255)


#define SerialNumberSize    16    // buffer size for SerialNumber string including terminating "\0"

