/*
 * port_box.c - jtag_port part for SimBox
 *
 */


/* $Id: port_box.c,v 1.1.1.1 2001/12/13 13:09:21 kanne Exp $ */

#include <linux/version.h>
#include <asm/io.h>
#include "jtag_port.h"

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,4,2)
#define clps_readl(off) (IO_##x)
#define clps_writel(val,off) IO_##x = val
#define clps_readb(off) (IO_##x)
#define clps_writeb(val,off) IO_##x = val
#endif

void setup_ports()
{
    // B7 (TMS), B4 (TDI), B3 (TCK)	- out
    clps_writeb ((clps_readb(PBDDR) & 0x67) | 0x98, PBDDR);
    // A5 (TDO)				- in
    clps_writeb ((clps_readb(PADDR) & 0xDF) | 0x00, PADDR); 
}

void write_jtag_byte(jtag_byte byte)
{
    bit_byte port;
    
    port.value = clps_readb (PBDR);
    
    port.bits.bit3 = byte.bits.tck;
    port.bits.bit4 = byte.bits.tdi;
    port.bits.bit7 = byte.bits.tms;

    clps_writeb (port.value, PBDR);
}

jtag_byte read_jtag_byte()
{
    jtag_byte byte;
    bit_byte port;
    
    port.value = clps_readb (PADR);
    byte.bits.tdo = port.bits.bit5;
    
    return (byte);
}

