#ifndef __RTAI_H__
#define __RTAI_H__

#include <linux/spinlock.h>
#include <asm/system.h>

static inline unsigned long rt_spin_lock_irqsave(spinlock_t *lock)
{
	unsigned long flags;
	hard_save_flags_and_cli(flags);
	spin_lock(lock);
	return flags;
}

static inline void rt_spin_unlock_irqrestore(unsigned long flags,spinlock_t *lock)
{
	spin_unlock(lock);
	hard_restore_flags(flags);
}

#endif
