#ifndef __RTAI_H__
#define __RTAI_H__

#include <linux/spinlock.h>

static inline unsigned long rt_spin_lock_irqsave(spinlock_t *lock)
{
	unsigned long flags;
	__asm__ __volatile__ (
		"\tmfmsr 0\n"
		"\trlwinm 0,0,0,17,15\n"
		"\tmtmsr 0\n"
		: "=r" (flags) : : "r0" );
	spin_lock(lock);
	return flags;
}

static inline void rt_spin_unlock_irqrestore(unsigned long flags,spinlock_t *lock)
{
	spin_unlock(lock);
	__asm__ __volatile__ (
		"\tmfmsr 0\n"
		"\trlwimi %0,0,0,17,15\n"
		"\tmtmsr %0\n"
		: : "r" (flags) : "r0" );
}

#endif
