/***********************  I n c l u d e  -  F i l e  ************************
 *  
 *         Name: men_vme_kernelif.h
 *
 *       Author: kp
 *        $Date: 2001/08/20 12:23:54 $
 *    $Revision: 1.1.2.1 $
 * 
 *  Description: header file to use MEN VME kernel interface
 *                      
 *     Switches: -
 *
 *-------------------------------[ History ]---------------------------------
 *
 * $Log: men_vme_kernelif.h,v $
 * Revision 1.1.2.1  2001/08/20 12:23:54  kp
 * *** empty log message ***
 *
 *---------------------------------------------------------------------------
 * (c) Copyright 2000 by MEN mikro elektronik GmbH, Nuernberg, Germany 
 ****************************************************************************/

#ifndef _MEN_VME_KERNELIF_H
#define _MEN_VME_KERNELIF_H

#ifdef __cplusplus
	extern "C" {
#endif

/*--------------------------------------+
|   DEFINES                             |
+--------------------------------------*/

/* VME space codes */
#define VME_A16_SPACE	1
#define VME_A24_SPACE	2
#define VME_A32_SPACE	3

#define VME_D16_ACCESS	0x100
#define VME_D32_ACCESS  0x200

/*--------------------------------------+
|   TYPDEFS                             |
+--------------------------------------*/
/* none */

/*--------------------------------------+
|   EXTERNALS                           |
+--------------------------------------*/
/* none */

/*--------------------------------------+
|   GLOBALS                             |
+--------------------------------------*/
/* none */

/*--------------------------------------+
|   PROTOTYPES                          |
+--------------------------------------*/
extern int vme_bus_to_phys( int space, u32 vmeadrs, void **physadrs_p );
extern int vme_request_irq(
	unsigned int vme_irq,
	void (*handler)(int, void *, struct pt_regs *),
	unsigned long flags,
	const char *device, 
	void *dev_id);
extern void vme_free_irq(unsigned int vme_irq, void *dev_id);
extern int vme_ilevel_control( int level, int enable );



#ifdef __cplusplus
	}
#endif

#endif	/* _MEN_VME_KERNELIF_H */
